#extension GL_OES_EGL_image_external : require
varying highp vec2 texCoordVarying;
precision mediump float;

uniform vec3 colorToReplace;
uniform float thresholdSensitivity;
uniform float smoothing;
uniform samplerExternalOES SamplerRGB;

void main()
{
	lowp vec3 srcRGB;
	srcRGB = texture2D(SamplerRGB, texCoordVarying).rgb;

    //src rgb to yuv
    mediump vec3 srcYUV;
    srcYUV.x = 0.2989 * srcRGB.r + 0.5866 * srcRGB.g + 0.1145 * srcRGB.b;
    srcYUV.y = 0.5647 * (srcRGB.b - srcYUV.x);
    srcYUV.z = 0.7132 * (srcRGB.r - srcYUV.x);

    //mask rgb to yuv
    mediump vec3 maskYUV;
    maskYUV.x = 0.2989 * colorToReplace.r + 0.5866 * colorToReplace.g + 0.1145 * colorToReplace.b;
    maskYUV.y = 0.5647 * (colorToReplace.b - maskYUV.x);
    maskYUV.z = 0.7132 * (colorToReplace.r - maskYUV.x);

	float blendValue = smoothstep(thresholdSensitivity, thresholdSensitivity + smoothing, distance(vec3(srcYUV.y, srcYUV.z, srcYUV.x), vec3(maskYUV.y, maskYUV.z, maskYUV.x)));

	gl_FragColor = vec4(srcRGB, blendValue);
//=======
//void main() {
//    lowp vec3 yuv = vec3(texture2D(SamplerY, texCoordVarying).r, texture2D(SamplerUV, texCoordVarying).rg) - vec3(16.0 / 255.0, 0.5, 0.5);
//    lowp vec3 rgb = colorConversionMatrix * yuv;
//    lowp mat3 matrix = mat3(0.2989,  0.5866,  0.1145,
//                            0.5000, -0.4183, -0.0810,
//                            0.1688, -0.3312,  0.5000);
//    lowp vec3 maskyuv = colorToReplace * matrix;
//    lowp vec3 W = vec3(0.2125, 0.7154, 0.0721);
//    float L = dot(rgb, W);
//    float maskL = dot(colorToReplace, W);
//    float blendValue = smoothstep(thresholdSensitivity, thresholdSensitivity + smoothing, distance(vec3(yuv.y, yuv.z, L), vec3(maskyuv.y, maskyuv.z, maskL)));
//    gl_FragColor = vec4(rgb, blendValue);
//>>>>>>> 183d53d2622903b57d0a958718ea9bc9f888ee84
}
