package com.taobao.movie.android.app.chat.item

import android.view.View
import android.widget.TextView

import com.taobao.listitem.recycle.RecyclerDataItem
import com.taobao.movie.android.home.R
import com.taobao.movie.android.common.im.chatroom.model.MessageNoticeTxtVO
import com.taobao.movie.android.common.im.chatroom.model.MessageVO

class ChatNoticeMessageItem(messageVO: MessageVO<*>) : RecyclerDataItem<ChatNoticeMessageItem.ViewHolder, MessageVO<*>>(messageVO) {

    override fun onBindViewHolder(viewHolder: ViewHolder) {
        if (data == null || data.message !is MessageNoticeTxtVO) {
            return
        }
        var messageNoticeTxtVO = data.message as MessageNoticeTxtVO
        viewHolder.noticeTxt.text = messageNoticeTxtVO.content
    }

    override fun getLayoutId(): Int {
        return R.layout.chat_notice_message_item
    }

    class ViewHolder(itemView: View) : ChatItemViewHolder(itemView) {

        val noticeTxt: TextView

        init {
            noticeTxt = itemView.findViewById<View>(R.id.notice_msg_txt) as TextView
        }
    }
}
