package com.taobao.movie.android.app.common.abtask

import com.taobao.movie.android.app.common.abtask.model.ABTestResponseModel
import com.taobao.movie.android.arch.BaseViewModel
import com.taobao.movie.android.net.mtop.rx.ApiException
import com.taobao.movie.android.net.mtop.rx.ShawShankApiObserver

/**
 * ABTest触达场景需要调用的请求
 */
class ABTestViewModel : BaseViewModel() {

    @JvmOverloads
    fun reachABTestScenario(scenario: String, onSuccess: ((ABTestResponseModel) -> Unit)? = null, onFail: ((ApiException) -> Unit)? = null) {
        val abTestRequest = AbTestRequest()
        abTestRequest.scenario = scenario
        abTestRequest.subscribe(this, object : ShawShankApiObserver.ApiConsumer<ABTestResponseModel>() {
            override fun onSuccess(resp: ABTestResponseModel?) {
                if (resp != null && onSuccess != null) {
                    onSuccess(resp)
                }
            }

            override fun onFail(e: ApiException) {
                if (onFail != null) {
                    onFail(e)
                }
            }
        })
    }
}