package com.taobao.movie.android.app.common.checkugc

import com.taobao.movie.android.arch.BaseViewModel
import com.taobao.movie.android.net.mtop.rx.ApiException
import com.taobao.movie.android.net.mtop.rx.ShawShankApiObserver
import com.taobao.movie.appinfo.util.ToastUtil

class CheckUgcContentViewModel : BaseViewModel() {

    fun checkUgcContent(content: String, onSuccess: (CheckUgcResponseModel) -> Unit) {
        val checkUgcContentRequest = CheckUgcContentRequest()
        checkUgcContentRequest.content = content
        checkUgcContentRequest.subscribe(this, object : ShawShankApiObserver.ApiConsumer<CheckUgcResponseModel>() {
            override fun onSuccess(resp: CheckUgcResponseModel?) {
                resp?.let {
                    onSuccess(it)
                }
            }

            override fun onFail(e: ApiException) {
                e.message?.let {
                    ToastUtil.showToast(it)
                }
            }
        })
    }
}