package com.taobao.movie.android.app.common.recycleritem

import android.text.TextUtils
import android.view.View
import android.widget.TextView
import com.taobao.listitem.recycle.CustomRecyclerViewHolder
import com.taobao.listitem.recycle.RecyclerDataItem
import com.taobao.listitem.recycle.RecyclerExtDataItem
import com.taobao.movie.android.app.common.widget.UserIconView
import com.taobao.movie.android.home.R
import com.taobao.movie.android.integration.oscar.model.CommunityCommentMainTabModel

class CommunityCommentMainTabItem(communityCommentMainTabModel: CommunityCommentMainTabModel)
    : RecyclerExtDataItem<CommunityCommentMainTabItem.ViewHolder,CommunityCommentMainTabModel>(communityCommentMainTabModel) {

    override fun onBindViewHolder(viewHolder: ViewHolder?) {
        data?.content?.let {
            viewHolder?.commentContent?.text = data.content.replace("\n","")
        }
        viewHolder?.userIconView?.initIcon(data.userVO,false)
        viewHolder?.userIconView?.setIconSize(15)
    }

    override fun getLayoutId(): Int = R.layout.community_comment_main_tab_item

    class ViewHolder(itemView: View) : CustomRecyclerViewHolder<CommunityCommentMainTabItem>(itemView) {
        var userIconView : UserIconView
        var commentContent: TextView
        init {
            userIconView = itemView.findViewById(R.id.user_icon_view)
            commentContent = itemView.findViewById(R.id.tv_comment_content)
        }
    }
}