package com.taobao.movie.android.app.common.widget

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.widget.FrameLayout
import android.widget.LinearLayout
import android.widget.TextView
import com.taobao.listitem.recycle.RecyclerExtDataItem
import com.taobao.movie.android.app.presenter.community.CommunityFeedCardModel
import com.taobao.movie.android.common.item.theme.ItemEvent
import com.taobao.movie.android.home.R
import com.taobao.movie.appinfo.util.DisplayUtil

class CommunityInputView @JvmOverloads constructor(context: Context,attributeSet: AttributeSet,defStyleAttr: Int = 0) : FrameLayout(context,attributeSet,defStyleAttr){

    private var sendBtn: TextView
    private var contentTxt: TextView
    private var listener: RecyclerExtDataItem.OnItemEventListener<Any>? = null
    private var rootLayout: LinearLayout
    private var communityFeedCardModel: CommunityFeedCardModel? = null

    init {
        var view = LayoutInflater.from(context).inflate(R.layout.community_input_view,this,true)
        sendBtn = view.findViewById(R.id.tv_send_txt)
        contentTxt = view.findViewById(R.id.tv_content)
        rootLayout = view.findViewById(R.id.ll_root_layout)
        sendBtn.text = "发送"
        contentTxt.text = "我想说..."
        setBackgroundResource(R.color.white)
        rootLayout.setOnClickListener {
            val viewLocation = IntArray(2)
            view.getLocationOnScreen(viewLocation)
            communityFeedCardModel?.scrollY = viewLocation[1] - DisplayUtil.getStatusBarHeight() - DisplayUtil.getActionBarHeight(context) - DisplayUtil.getNavigationBarHeight()
            listener?.onEvent(ItemEvent.EVENT_ID_COMMUNITY_INPUT_CLICK,communityFeedCardModel,null)
        }
        contentTxt.setOnClickListener {
            val viewLocation = IntArray(2)
            view.getLocationOnScreen(viewLocation)
            communityFeedCardModel?.scrollY = viewLocation[1] - DisplayUtil.getStatusBarHeight() - DisplayUtil.getActionBarHeight(context) - DisplayUtil.getNavigationBarHeight()
            listener?.onEvent(ItemEvent.EVENT_ID_COMMUNITY_INPUT_CLICK,communityFeedCardModel,null)
        }
    }

    fun notifyContent(content:String) {
        contentTxt.text = content
    }

    fun initData(communityFeedCardModel: CommunityFeedCardModel?) {
        this.communityFeedCardModel = communityFeedCardModel
    }

    fun setOnItemClickListener(listener: RecyclerExtDataItem.OnItemEventListener<Any>){
        this.listener = listener
    }
}