package com.taobao.movie.android.app.common.widget

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.FrameLayout
import android.widget.TextView
import com.taobao.movie.android.app.presenter.community.CommunityFeedCardModel
import com.taobao.movie.android.common.widget.CommunityFeedCardImageView
import com.taobao.movie.android.commonui.widget.SimpleDraweeView
import com.taobao.movie.android.commonui.widget.shapebuilder.ShapeBuilder
import com.taobao.movie.android.home.R
import com.taobao.movie.appinfo.util.DisplayUtil
import com.taobao.movie.appinfo.util.ResHelper

class CommunityPostView @JvmOverloads constructor(context: Context, attributeSet: AttributeSet, defStyleAttr: Int = 0) : FrameLayout(context,attributeSet,defStyleAttr){

    var filmPost: CommunityFeedCardImageView
    var filmColumnTxt: TextView
    var filmFilmNameTxt: TextView
    var lineView: View
    var filmIntroTxt: TextView
    var filmSecondTxt: TextView
    var topMask: View
    var bottomMask: View

    init {
        val view = LayoutInflater.from(context).inflate(R.layout.community_post_view,this,true)
        filmPost = view.findViewById(R.id.img_film_post)
        filmColumnTxt = view.findViewById(R.id.colum_name_txt)
        filmFilmNameTxt = view.findViewById(R.id.film_name_txt)
        lineView = view.findViewById(R.id.text_line)
        filmIntroTxt = view.findViewById(R.id.tv_film_intro)
        filmSecondTxt = view.findViewById(R.id.tv_second_content)
        topMask = view.findViewById(R.id.top_mask)
        bottomMask = view.findViewById(R.id.bottom_mask)
        ShapeBuilder.create().gradient(ResHelper.getColor(R.color.transparent_black_040),
                ResHelper.getColor(R.color.transparent_black_022),
                ResHelper.getColor(R.color.transparent_black_00)).build(topMask)
        ShapeBuilder.create().gradient(ResHelper.getColor(R.color.transparent_black_00),
                ResHelper.getColor(R.color.transparent_black_022),
                ResHelper.getColor(R.color.transparent_black_060)).build(bottomMask)
    }

    fun initData(communityFeedCardModel: CommunityFeedCardModel) {
        if ((communityFeedCardModel.feedVO != null &&
                !communityFeedCardModel.feedVO.imageList.isNullOrEmpty()) || !communityFeedCardModel.backgroundImage.isNullOrEmpty()) {
            lineView.visibility = if(communityFeedCardModel.showName.isNullOrEmpty() || communityFeedCardModel.columnName.isNullOrEmpty()) View.GONE else View.VISIBLE
            filmFilmNameTxt.visibility = if(communityFeedCardModel.showName.isNullOrEmpty()) View.GONE else View.VISIBLE
            filmColumnTxt.visibility = if(communityFeedCardModel.columnName.isNullOrEmpty()) View.GONE else View.VISIBLE
            filmColumnTxt.text = communityFeedCardModel.columnName
            filmFilmNameTxt.text = communityFeedCardModel.showName
            filmIntroTxt.text = if (communityFeedCardModel.feedVO != null && communityFeedCardModel.feedVO.title != null) communityFeedCardModel.feedVO.title else communityFeedCardModel.content
            val imageUrl = if(communityFeedCardModel.backgroundImage.isNullOrEmpty()) communityFeedCardModel.feedVO.imageList[0] else communityFeedCardModel.backgroundImage
            filmPost.setData(imageUrl, communityFeedCardModel.coverWidth, communityFeedCardModel.coverHeight, DisplayUtil.getDisplayWidthInPx() - DisplayUtil.dp2pxInt(30f))
            var time = if (communityFeedCardModel.activityTime.isNullOrEmpty()) "" else communityFeedCardModel.activityTime
            var address = if (communityFeedCardModel.activityAddress.isNullOrEmpty()) "" else communityFeedCardModel.activityAddress
            filmSecondTxt.visibility = if ((time+address).isEmpty()) View.GONE else View.VISIBLE
            filmSecondTxt.text = time+"  "+address
        } else {
            visibility = View.GONE
        }
    }
}