package com.taobao.movie.android.app.community

import android.graphics.Typeface
import android.os.Bundle

import com.taobao.movie.android.commonui.component.BaseToolBarActivity
import com.taobao.movie.android.commonui.widget.MTitleBar
import com.taobao.movie.android.commonui.widget.MToolBar
import com.taobao.movie.android.home.R
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTFacade
import com.taobao.movie.appinfo.util.ResHelper


/**
 * 电影日历
 */
class CommunityFilmCalendarActivity : BaseToolBarActivity() {
    private lateinit var mToolBar: MToolBar
    private lateinit var mFragment: CommunityFilmCalendarFragment

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.film_calendar_detail_activity)
        UTFacade.startExpoTrack(this)
        initToolbar()
        mFragment = CommunityFilmCalendarFragment()
        mFragment.arguments = Bundle().apply { putString(CommunityFilmCalendarFragment.KEY_PAGE_FROM, intent?.getStringExtra(CommunityFilmCalendarFragment.KEY_PAGE_FROM)) }
        supportFragmentManager.beginTransaction().add(R.id.film_calendar_content, mFragment).commitAllowingStateLoss()
    }

    protected fun initToolbar() {
        mToolBar = findViewById(R.id.toolbar)
        setSupportActionBar(mToolBar)
    }

    override fun initTitleBar(titleBar: MTitleBar) {
        titleBar.setTitle("电影日历")
        titleBar.titleTextView.typeface = Typeface.DEFAULT_BOLD
        titleBar.setLeftButtonTextColor(ResHelper.getColor(R.color.black))
        titleBar.setLeftButtonText(getString(R.string.icon_font_titlebar_back))
        titleBar.setLineVisable(true)
        titleBar.leftButtonView.setOnClickListener { v -> finish() }
        titleBar.setBackgroundColor(ResHelper.getColor(R.color.white))
    }

    override fun finish() {
        super.finish()
    }
}
