package com.taobao.movie.android.app.community.recycleitem

import android.view.View
import com.taobao.movie.android.app.common.widget.CommunityCommentView
import com.taobao.movie.android.app.common.widget.CommunityInputView
import com.taobao.movie.android.app.common.widget.CommunityPostView
import com.taobao.movie.android.app.presenter.community.CommunityFeedCardModel
import com.taobao.movie.android.app.presenter.community.CommunityFeedCardModel.*
import com.taobao.movie.android.common.scheme.MovieNavigator
import com.taobao.movie.android.home.R
import com.taobao.movie.android.integration.oscar.model.CommunityCommentMainTabModel
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTFacade

/**
 * 社区2.0 活动卡片 资讯卡片公用
 */
class CommunityFeedArticleItem(communityFeedCardModel: CommunityFeedCardModel,private val mListener: OnItemEventListener<Any>) : CommunityFeedBaseItem<CommunityFeedArticleItem.ViewHolder,CommunityFeedCardModel>(communityFeedCardModel),View.OnClickListener {

    override fun onBindViewHolder(viewHolder: ViewHolder?) {
        super.onBindViewHolder(viewHolder)
        viewHolder?.communityPostView?.initData(data)
        viewHolder?.communityCommentView?.initComment(data.commentItemList)
        viewHolder?.communityCommentView?.visibility = if (data?.commentItemList.isNullOrEmpty()) View.GONE else View.VISIBLE
        viewHolder?.communityInputView?.setOnItemClickListener(mListener)
        viewHolder?.communityInputView?.initData(data)
        viewHolder?.itemView?.setOnClickListener(this)
        viewHolder?.communityCommentView?.setOnClickListener(this)
    }

    override fun onClick(v: View) {
        UTFacade.buttonClickWithoutPage("DiscussCardClick", "type", data.columnType.toString() + "", "discuss_id", data.discussionId, "show_id", data.referShowId)
        when(data.columnType) {
            COMMUNITY_FEED_ACTIVITY -> MovieNavigator.handleUrl(v.context,data.jumpUrl)
            COMMUNITY_FEED_ANOTHER_ACTIVITY -> MovieNavigator.handleUrl(v.context,data.jumpUrl)
            COMMUNITY_FEED_INFORMATION ->  if(data.feedVO != null) MovieNavigator.handleUrl(v.context,data.feedVO.jumpUrl)
        }
    }

    override fun addComment(communityCommentMainTabModel: CommunityCommentMainTabModel?) {
        if(viewHolder == null) {
            return
        }
        viewHolder.communityCommentView.visibility = View.VISIBLE
        viewHolder.communityCommentView.addComment(communityCommentMainTabModel)
    }

    override fun getLayoutId(): Int {
        return R.layout.community_feed_article_item
    }

    class ViewHolder(itemView : View) : CommunityFeedBaseItem.ViewHolder(itemView){
        var communityPostView : CommunityPostView
        var communityCommentView : CommunityCommentView
        var communityInputView : CommunityInputView

        init {
            communityPostView = itemView.findViewById(R.id.community_post)
            communityCommentView = itemView.findViewById(R.id.community_comment_view)
            communityInputView = itemView.findViewById(R.id.community_input_view)
        }
    }
}