package com.taobao.movie.android.app.community.recycleitem

import android.os.Bundle
import android.view.View
import android.widget.TextView
import com.taobao.movie.android.app.common.widget.CommunityCommentView
import com.taobao.movie.android.app.common.widget.CommunityInputView
import com.taobao.movie.android.app.presenter.community.CommunityFeedCardModel
import com.taobao.movie.android.common.IntentConstants
import com.taobao.movie.android.common.scheme.MovieNavigator
import com.taobao.movie.android.commonui.battle.BattleVoteView
import com.taobao.movie.android.home.R
import com.taobao.movie.android.integration.oscar.model.CommunityBattleModuleMo
import com.taobao.movie.android.integration.oscar.model.CommunityCommentMainTabModel
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTFacade
import com.taobao.movie.appinfo.util.DataUtil

/**
 * 社区 battle
 */
class CommunityFeedBattleItem (communityFeedCardModel: CommunityFeedCardModel,private val mListener: OnItemEventListener<Any>) : CommunityFeedBaseItem<CommunityFeedBattleItem.ViewHolder, CommunityFeedCardModel>(communityFeedCardModel),View.OnClickListener  {

    override fun onBindViewHolder(viewHolder : ViewHolder?) {
        super.onBindViewHolder(viewHolder)
        viewHolder?.battleVoteView?.initView(data?.battleModel)
        viewHolder?.communityCommentView?.initComment(data?.commentItemList)
        viewHolder?.communityCommentView?.visibility = if (data?.commentItemList.isNullOrEmpty()) View.GONE else View.VISIBLE
        viewHolder?.communityInputView?.setOnItemClickListener(mListener)
        viewHolder?.communityInputView?.initData(data)
        viewHolder?.columnTxt?.text = data?.columnName
        viewHolder?.filmNameTxt?.text = data?.showName
        viewHolder?.titleTxt?.text = data?.content
        viewHolder?.itemView?.setOnClickListener(this)
        viewHolder?.communityCommentView?.setOnClickListener(this)
    }

    override fun addComment(communityCommentMainTabModel: CommunityCommentMainTabModel?) {
        if(viewHolder == null) {
            return
        }
        viewHolder.communityCommentView.visibility = View.VISIBLE
        viewHolder.communityCommentView.addComment(communityCommentMainTabModel)
    }

    override fun onClick(v: View) {
        UTFacade.buttonClickWithoutPage("DiscussCardClick", "type", data.columnType.toString() + "", "discuss_id", data.discussionId, "show_id", data.referShowId)
        val bundle = Bundle()
        bundle.putString(IntentConstants.KEY_BATTLE_ID, data.id.toString() + "")
        bundle.putBoolean(IntentConstants.KEY_NEED_SHOW_KEYBOARD, false)
        bundle.putBoolean(IntentConstants.KEY_NEED_SCROLL_TO_COMMENT, false)
        bundle.putSerializable(IntentConstants.KEY_BATTLE_MODEL, data.battleModel)
        MovieNavigator.gotoAction(v.context, IntentConstants.Action.ACTION_BATTLE_DETAIL, bundle)
    }

    override fun getLayoutId(): Int {
        return R.layout.community_feed_battle_item
    }

    class ViewHolder(itemView: View) : CommunityFeedBaseItem.ViewHolder(itemView){
        var battleVoteView : BattleVoteView
        var titleTxt : TextView
        var communityCommentView : CommunityCommentView
        var columnTxt : TextView
        var filmNameTxt : TextView
        var communityInputView: CommunityInputView

        init {
            battleVoteView = itemView.findViewById(R.id.battle_vote_view)
            titleTxt = itemView.findViewById(R.id.tv_title)
            communityCommentView = itemView.findViewById(R.id.comment_view)
            columnTxt = itemView.findViewById(R.id.colum_name_txt)
            filmNameTxt = itemView.findViewById(R.id.film_name_txt)
            communityInputView = itemView.findViewById(R.id.community_input_view)
        }

    }
}