package com.taobao.movie.android.app.oscar.ui.community

import android.content.Context
import android.content.Intent
import android.graphics.Typeface
import android.os.Bundle
import com.taobao.movie.android.app.oscar.ui.community.fragment.FilmFestivalIndexFragment
import com.taobao.movie.android.commonui.component.BaseToolBarActivity
import com.taobao.movie.android.commonui.utils.ImmersionStatusBar
import com.taobao.movie.android.commonui.widget.MTitleBar
import com.taobao.movie.android.commonui.widget.MToolBar
import com.taobao.movie.android.home.R
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTFacade

class FilmFestivalIndexActivity : BaseToolBarActivity() {

    private lateinit var toolbar: MToolBar
    private lateinit var mFragment: FilmFestivalIndexFragment


    companion object {
        fun gotoFilmFestivalIndexActivity(context: Context?, pageFrom: String?) {
            if (context == null) {
                return
            }
            context.startActivity(Intent(context, FilmFestivalIndexActivity::class.java).apply { putExtra(FilmFestivalIndexFragment.KEY_PAGE_FROM, pageFrom) })
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        ImmersionStatusBar.setupWindow(window)
        ImmersionStatusBar.statusBarDark(this, true)
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_film_festival)
        UTFacade.startExpoTrack(this)
        mFragment = FilmFestivalIndexFragment()
        mFragment.arguments = Bundle().apply { putString(FilmFestivalIndexFragment.KEY_PAGE_FROM, intent?.getStringExtra(FilmFestivalIndexFragment.KEY_PAGE_FROM)) }
        initToolbar()
        if (savedInstanceState == null) {
            supportFragmentManager.beginTransaction().add(R.id.film_festival_content, mFragment).commitAllowingStateLoss()
        }

    }

    protected fun initToolbar() {
        toolbar = findViewById(R.id.toolbar)
        toolbar.setType(MToolBar.IMMERSION)
        setSupportActionBar(toolbar)
    }


    override fun initTitleBar(titleBar: MTitleBar?) {
        titleBar?.setTitle("电影节")
        titleBar?.setLeftButtonText(getString(R.string.icon_font_titlebar_back))
        titleBar?.setLeftButtonListener { onBackPressed() }
        titleBar?.setLineVisable(true)
        titleBar?.titleTextView?.typeface = Typeface.DEFAULT_BOLD
    }


}