package com.taobao.movie.android.app.oscar.ui.community.fragment

import android.os.Bundle
import android.support.v4.app.Fragment
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.taobao.movie.android.commonui.component.BaseFragment
import com.taobao.movie.android.commonui.component.PageSelectable
import com.taobao.movie.android.commonui.utils.ImmersionStatusBar
import com.taobao.movie.android.commonui.wrapper.IFragmentContainer
import com.taobao.movie.android.home.R

/**
 * 社区主fragment，新建一个是便于做ab
 */
class CommunityDelegateFragment : BaseFragment(), IFragmentContainer, PageSelectable {

    private lateinit var mCommunityTabsFragment: CommunityTabsFragment
    private lateinit var mCommunityNewHomeFragment: CommunityNewHomeFragment

    private var mIsCommnutitTabSelect: Boolean = false //从主页的角度看，本Fragment是否被选中

    private var mSelectFragment: BaseFragment? = null


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        ImmersionStatusBar.statusBarDark(this, false)

    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        super.onCreateView(inflater, container, savedInstanceState)
        var view: View = inflater.inflate(R.layout.community_delegate_frag, null)
        mIsCommnutitTabSelect = true
        return view
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        //社区2.0全量
//        if (ABTestConfigProvider.getProvider().getAllExperimentConfigs().isCommunityTypeOne) { //社区1.0
//            mCommunityTabsFragment = CommunityTabsFragment()
//            mSelectFragment = mCommunityTabsFragment
//
//        } else { //社区2.0
            mCommunityNewHomeFragment = CommunityNewHomeFragment()
            mSelectFragment = mCommunityNewHomeFragment
//        }
        val fragmentTransaction = childFragmentManager.beginTransaction()
        fragmentTransaction.add(R.id.frag_content, mSelectFragment!!).commitAllowingStateLoss()
    }


    override fun onHiddenChanged(hidden: Boolean) {
        super.onHiddenChanged(hidden)
        if (!hidden) {
            ImmersionStatusBar.statusBarDark(this, false)
        }
    }


    fun doDoubleClick() {
        val frag = visibleFragment
        if (frag is CommunityTabsFragment) {
            frag.doDoubleClick()
        }
        if (frag is CommunityNewHomeFragment) {
            frag.doDoubleClick()
        }
    }


    override fun getVisibleFragment(): Fragment? {
        return mSelectFragment

    }

    //来自MainActivity的pageSelect
    override fun onPageSelect(bundle: Bundle?) {
        if (bundle != null) {
            val value = bundle.getString("location")
            if (TextUtils.equals(value, "hotsubject")) {
                CommunitySquareFragment.setJumpToSubjectItem()
            }
            if (mSelectFragment is PageSelectable) {
                (mSelectFragment as PageSelectable).onPageSelect(bundle)
            }
        }
    }

}
