package com.taobao.movie.android.app.oscar.ui.community.fragment

import android.app.Activity
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.os.Bundle
import android.support.v4.content.LocalBroadcastManager
import android.support.v4.graphics.ColorUtils
import android.support.v7.widget.RecyclerView
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import android.view.ViewGroup
import android.view.inputmethod.InputMethodManager
import android.widget.*
import com.taobao.listitem.recycle.RecyclerExtDataItem
import com.taobao.movie.android.app.abtest.ABTestConfigProvider
import com.taobao.movie.android.app.common.abtask.ABTestViewModel
import com.taobao.movie.android.app.community.CommunityFilmCalendarFragment
import com.taobao.movie.android.app.community.adddiscuss.SelectQuestionOrDiscussDialog
import com.taobao.movie.android.app.community.adddiscuss.WelcomeToJoinAiyiDialog
import com.taobao.movie.android.app.community.recycleitem.*
import com.taobao.movie.android.app.home.tab.MovieTabMoProvider
import com.taobao.movie.android.app.home.tab.TabChangeEvent
import com.taobao.movie.android.app.home.util.HomeUtil
import com.taobao.movie.android.app.oscar.ui.community.FilmFestivalIndexActivity
import com.taobao.movie.android.app.oscar.ui.community.common.DiscussItemEvents
import com.taobao.movie.android.app.oscar.ui.homepage.EVENT_AIYI_REFRESH_FINISH
import com.taobao.movie.android.app.oscar.ui.smartvideo.item.CommunityAiyiItem
import com.taobao.movie.android.app.oscar.ui.smartvideo.item.CommunityFestivalContainerItem
import com.taobao.movie.android.app.oscar.ui.smartvideo.item.CommunityFilmHallItem
import com.taobao.movie.android.app.oscar.ui.smartvideo.item.CommunityShowAndSoonContainerItem
import com.taobao.movie.android.app.oscar.ui.util.SoftKeyBoardListener
import com.taobao.movie.android.app.oscar.ui.util.SoftKeyBoardListener.OnSoftKeyBoardChangeListener
import com.taobao.movie.android.app.presenter.community.*
import com.taobao.movie.android.app.presenter.community.CommunityFeedCardModel.*
import com.taobao.movie.android.app.presenter.filmdetail.FilmDoFavorPresenter
import com.taobao.movie.android.app.ui.common.WantedTipUtil
import com.taobao.movie.android.app.video.videoplaymanager.VideoNewCommunityManager
import com.taobao.movie.android.app.vinterface.community.ICommunityJoinAiyiView
import com.taobao.movie.android.app.vinterface.community.ICommunityNewHomeView
import com.taobao.movie.android.app.vinterface.filmdetail.IFilmDoFavorView
import com.taobao.movie.android.arch.obtainViewModel
import com.taobao.movie.android.common.IntentConstants
import com.taobao.movie.android.common.item.theme.ItemEvent
import com.taobao.movie.android.common.login.LoginExtServiceImpl
import com.taobao.movie.android.common.login.LoginHelper
import com.taobao.movie.android.common.login.checkSession
import com.taobao.movie.android.common.scheme.MovieNavigator
import com.taobao.movie.android.common.scheme.NavigatorUtil
import com.taobao.movie.android.common.weex.TppNativeToWxNotifyEvent
import com.taobao.movie.android.commonui.component.BaseActivity
import com.taobao.movie.android.commonui.component.PageSelectable
import com.taobao.movie.android.commonui.component.lcee.ILceeView
import com.taobao.movie.android.commonui.component.lcee.LceeListFragment
import com.taobao.movie.android.commonui.component.lcee.MultiPresenters
import com.taobao.movie.android.commonui.recyclerview.LoadingItem
import com.taobao.movie.android.commonui.utils.ImmersionStatusBar
import com.taobao.movie.android.commonui.utils.SqmKeeper
import com.taobao.movie.android.commonui.utils.UiUtils
import com.taobao.movie.android.commonui.widget.FavoriteManager
import com.taobao.movie.android.commonui.widget.MTitleBar
import com.taobao.movie.android.commonui.widget.MTitleBarView
import com.taobao.movie.android.commonui.widget.MToolBar
import com.taobao.movie.android.commonutil.LocalEvent
import com.taobao.movie.android.commonutil.LocalEventBus
import com.taobao.movie.android.home.R
import com.taobao.movie.android.integration.CommonConstants
import com.taobao.movie.android.integration.common.service.LoginExtService
import com.taobao.movie.android.integration.common.service.RegionExtService
import com.taobao.movie.android.integration.oscar.model.CommunityCommentMainTabModel
import com.taobao.movie.android.integration.oscar.model.DiscussionMo
import com.taobao.movie.android.integration.oscar.model.ShowMo
import com.taobao.movie.android.integration.oscar.model.ShowResultIndexMo
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTConstants
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTFacade
import com.taobao.movie.android.sdk.infrastructure.usertrack.ViewOnClickListener
import com.taobao.movie.appinfo.util.*
import com.taobao.movie.shawshank.time.ServerTime
import com.taobao.movie.statemanager.state.CoreState
import com.taobao.movie.statemanager.state.EmptyState
import com.taobao.movie.statemanager.state.SimpleProperty
import de.greenrobot.event.EventBus

/**
 *  Created by 天逐 on 2019-12-05.
 *  function:新社区主页
 */
class CommunityNewHomeFragment : LceeListFragment<MultiPresenters<ILceeView>>(), ICommunityNewHomeView, View.OnClickListener,
        RecyclerExtDataItem.OnItemEventListener<Any>, SelectQuestionOrDiscussDialog.OnPublishClickListener, ICommunityJoinAiyiView, FavoriteManager.notifyFavorite, IFilmDoFavorView, PageSelectable {
    companion object {
        const val SHOW_AIYI_TIME_SP_KEY = "show_aiyi_time_sp_key"
        const val Page_NewMVCommunityTab = "Page_NewMVCommunityTab"
        const val Page_NewMVCommunityTabSPM = "13835003"
    }

    private val abTestViewModel by lazy(LazyThreadSafetyMode.NONE) {
        obtainViewModel(ABTestViewModel::class.java)
    }
    private lateinit var mTitleBar: MTitleBarView
    private lateinit var mToolbar: MToolBar
    private lateinit var mPresenter: CommunityNewHomePresenter
    private lateinit var mJoinAiyiPresenter: CommunityAiyiJoinPresenter
    private lateinit var mFarvorPresenter: FilmDoFavorPresenter<IFilmDoFavorView>
    private lateinit var loadingItem: LoadingItem
    private lateinit var mPublishBtn: ImageView
    private var maxHeight: Int = 0
    private var scrollY: Int = 0
    private val minHeiggt: Int = DisplayUtil.dp2px(50f).toInt()
    private var discussDialog: SelectQuestionOrDiscussDialog? = null
    private var hasShowWelcomeAiyi = false
    private val mSixPicRecycledViewPool by lazy(LazyThreadSafetyMode.NONE) {
        RecyclerView.RecycledViewPool()
    }
    private lateinit var mVideoCommunityManager: VideoNewCommunityManager
    private lateinit var commentInputLayout: LinearLayout
    private lateinit var commentEditText: EditText
    private lateinit var commentSendBtn: TextView
    private lateinit var commentLayout: FrameLayout
    private var commentFeedCardModel: CommunityFeedCardModel? = null
    private var mScrollY = 0
    private var festivalTimestamp: Long? = null
    private var aiyiItem: CommunityAiyiItem? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        UTConstants.SPM_Map[Page_NewMVCommunityTab] = Page_NewMVCommunityTabSPM
        super.onCreate(savedInstanceState)
        setUTPageEnable(true)
        utPageName = Page_NewMVCommunityTab

        maxHeight = DisplayUtil.dp2px(210f).toInt()
        FavoriteManager.getInstance().registerDefault(this)
        EventBus.getDefault().register(this)
    }

    override fun initViewContent(layoutView: View, savedInstanceState: Bundle?) {
        super.initViewContent(layoutView, savedInstanceState)
        refreshLayout.setProgressViewOffset(true, minHeiggt, minHeiggt * 2)
        mToolbar = overallView.findViewById(R.id.toolbar)
        mToolbar.setType(MToolBar.IMMERSION_OVERLAY)
        mToolbar.visibility = View.GONE
        mTitleBar = mToolbar.findViewById(R.id.titlebar)
        mTitleBar.setOnDoubleClickListener(this)
        mPublishBtn = layoutView.findViewById(R.id.send_discuss_btn)
        commentLayout = layoutView.findViewById(R.id.fl_comment_input)
        commentEditText = layoutView.findViewById(R.id.et_chat_message_edit)
        commentSendBtn = layoutView.findViewById(R.id.tv_chat_send_btn)
        commentInputLayout = layoutView.findViewById(R.id.ll_community_chat_container)
        mPublishBtn.setOnClickListener(this)
        commentSendBtn.setOnClickListener(this)
        commentLayout.setOnClickListener(this)
        initTitleBar()
        loadingItem = LoadingItem(getString(R.string.exception_item), listener)
        mVideoCommunityManager = VideoNewCommunityManager()
        mVideoCommunityManager.setVideoRecyclerView(recyclerView, adapter)
        recyclerView.addOnScrollListener(object : RecyclerView.OnScrollListener() {
            override fun onScrolled(recyclerView: RecyclerView, dx: Int, dy: Int) {
                super.onScrolled(recyclerView, dx, dy)
                scrollY = recyclerView.computeVerticalScrollOffset()
                if (scrollY < 0) {
                    scrollY = 0
                }
                val percent = Math.abs(scrollY) * 1f / maxHeight
                syncCommunityTitleBar(percent)
                mVideoCommunityManager.onScrolled(recyclerView)
            }
        })
        showLoadingView(false)
        mPresenter.loadData(true)
        setTitleBarRightButton()
        initAiyiDialog()
        //监听键盘的变化
        SoftKeyBoardListener.setListener(activity, object : OnSoftKeyBoardChangeListener {
            override fun keyBoardShow(height: Int) {
                commentLayout.visibility = View.VISIBLE
                commentEditText.requestFocus()
                recyclerView.scrollBy(0,mScrollY - height - DisplayUtil.dp2pxInt(55f))
                recyclerView.postDelayed({
                    var commentInputParams = commentInputLayout.layoutParams as ViewGroup.MarginLayoutParams
                    commentInputParams.bottomMargin = height-DisplayUtil.dp2pxInt(55f)
                    commentInputLayout.layoutParams = commentInputParams
                },100)
            }

            override fun keyBoardHide(height: Int) {
                commentLayout.visibility = View.GONE
                commentEditText.clearFocus()
                commentEditText.clearComposingText()
                var commentInputParams = commentInputLayout.layoutParams as ViewGroup.MarginLayoutParams
                commentInputParams.bottomMargin = 0
                commentInputLayout.layoutParams = commentInputParams
            }
        })
        commentEditText.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {}
            override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {}
            override fun afterTextChanged(s: Editable) {
                if (commentEditText.text.isNullOrEmpty()) {
                    commentSendBtn.setTextColor(ResHelper.getColor(R.color.long_video_price))
                    commentSendBtn.isEnabled = false
                } else {
                    commentSendBtn.setTextColor(ResHelper.getColor(R.color.button_comment_favor))
                    commentSendBtn.isEnabled = true
                }
            }
        })
        //注册广播监听器
        LocalBroadcastManager.getInstance(activity!!)
                .registerReceiver(cityChangeBroadcastReceiver, IntentFilter(RegionExtService.ACTION_CITY_CHANGED))
        abTestViewModel.reachABTestScenario("discovery_tab",onSuccess = {
            ABTestConfigProvider.getProvider().updateScenarioParams(it.scenario,it.params)
        })

        LocalEventBus.getDefault().register(this, LocalEventBus.EventReceiver<LocalEvent> {
            if (it.type == EVENT_AIYI_REFRESH_FINISH) {
                mPresenter.loadData(true)
            }
        })
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        if (savedInstanceState != null) {
            val percent = savedInstanceState.getFloat("percent")
            if (percent >= 0) {
                UiUtils.syncCommunityTitleBar(activity, mToolbar, percent)
            }
        }
    }

    override fun onSaveInstanceState(outState: Bundle) {
        val percent = (Math.abs(recyclerView.scrollY) / maxHeight).toFloat()
        outState.putFloat("percent", Math.abs(percent))
        super.onSaveInstanceState(outState)
    }

    override fun createPresenter(): MultiPresenters<ILceeView> {
        mPresenter = CommunityNewHomePresenter()
        mJoinAiyiPresenter = CommunityAiyiJoinPresenter()
        mFarvorPresenter = FilmDoFavorPresenter<IFilmDoFavorView>()
        return MultiPresenters(mPresenter, mJoinAiyiPresenter, mFarvorPresenter)
    }

    /**
     * 城市变化广播监听器
     */
    private var cityChangeBroadcastReceiver: BroadcastReceiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context, intent: Intent) {
            if (UiUtils.isFragmentStateValid(this@CommunityNewHomeFragment)) {
                onRefreshClick()
            }
        }
    }

    private fun syncCommunityTitleBar(percent: Float) {
        var percent = percent
        mToolbar.titleBar.setLineVisable(false)
        mToolbar.titleBar.setLineVisable(false)
        if (percent >= 1) {
            percent = 1f
            ImmersionStatusBar.statusBarDark(activity, true)
        } else {
            ImmersionStatusBar.statusBarDark(activity, false)
        }

        if (percent > 0.9f) {
            val textColor = ColorUtils.setAlphaComponent(0x00000000, (255 * percent).toInt())
            mToolbar.titleBar.titleTextView.setTextColor(textColor)
            if (mToolbar.titleBar.right2Button.getTag(R.id.tag_title_right_enable) as Boolean) {
                //mToolbar.titleBar.setRight2Button2TextColor(textColor)
                mToolbar.titleBar.setRight2ButtonTextColor(textColor)
                mToolbar.titleBar.right2Button.isClickable = true
                mToolbar.titleBar.right2Button.visibility = View.VISIBLE
            } else {
                mToolbar.titleBar.right2Button.visibility = View.GONE
            }
            val bgColor = ColorUtils.setAlphaComponent(0x00ffffff, (255 * percent).toInt())
            mToolbar.setBackgroundColor(bgColor)
            mToolbar.visibility = View.VISIBLE
        } else {
            val textColor = 0x00000000
            val bgColor = 0x00000000
            mToolbar.titleBar.titleTextView.setTextColor(textColor)
            //mToolbar.titleBar.setRight2Button2TextColor(textColor)
            mToolbar.titleBar.setRight2ButtonTextColor(textColor)
            mToolbar.titleBar.right2Button.isClickable = false
            mToolbar.visibility = View.GONE
            mToolbar.setBackgroundColor(bgColor)
        }
    }

    private fun setTitleBarRightButton() {
        if (mPresenter.isAddAiyi) {
            mToolbar.titleBar.right2Button.isClickable = false
            mToolbar.titleBar.right2Button.visibility = View.GONE
            mToolbar.titleBar.right2Button.setTag(R.id.tag_title_right_enable, false)
        } else {
            mToolbar.titleBar.right2Button.visibility = View.VISIBLE
            mToolbar.titleBar.right2Button.setTag(R.id.tag_title_right_enable, true)
        }
    }

    override fun onRefresh(pullToRefresh: Boolean): Boolean {
        if (pullToRefresh) {
            recyclerView.smoothScrollToPosition(0)
            mPresenter.loadData(true)
        } else {
            showLoadingView(true)
            mPresenter.loadData(false)
        }
        return false
    }

    override fun onRefreshClick() {
        onRefresh(true)
    }

    override fun getLayoutId(): Int {
        return R.layout.fragment_new_community
    }


    private fun initTitleBar() {
        val showSettingRedPoint = HomeUtil.needShowSettingsRedPoint()
        if (showSettingRedPoint) {
            HomeUtil.insertLocalRedPoint(baseActivity, CommonConstants.BADGE_ID_SETTINGS)
        }
        mTitleBar.setType(MTitleBar.TYPE_OVERLAY_MINE)
        mTitleBar.setTitle(getString(R.string.tab_title_community_b))
        mTitleBar.titleTextView.textSize = 18.0f
        //mTitleBar.setRight2Button2Text(getString(R.string.community_aiyi_add))
        //mTitleBar.setRight2Button2TextSize(16)
        mTitleBar.setRight2ButtonText(getString(R.string.community_aiyi_add))
        mTitleBar.setRight2ButtonTextSize(16)
        mTitleBar.setRight2ButtonListener(object : ViewOnClickListener() {
            public override fun onClicked(view: View) {
                UTFacade.buttonClickWithoutPage("YilianJoinClick", "status", "0")
                startAddYiai()
            }
        })

        mTitleBar.getTitleTextView().setOnClickListener(null)

    }


    override fun onClick(v: View?) {
        if (v === mPublishBtn) {
            try {
                discussDialog = SelectQuestionOrDiscussDialog()
                discussDialog?.setOnPublishClickListener(this)
                discussDialog?.show(fragmentManager, "SelectQuestionOrDiscussDialog")
            } catch (e: Exception) {

            }

        } else if (v?.id == R.id.tv_chat_send_btn) {
            if (!commentEditText.text.isNullOrEmpty()) {
                commentFeedCardModel?.let {
                    UTFacade.buttonClickWithoutPage("DiscussCardCommentBtnClick",
                            "type", it.columnType.toString(), "discuss_id", it.discussionId, "show_id", it.referShowId)
                }
                mPresenter.sendComment(commentFeedCardModel?.commentType, commentFeedCardModel?.commentTargetId, commentEditText.text.toString())
            }
        } else if (v?.id == R.id.fl_comment_input) {
            showOrHideSoftKeyboard(false)
        }
    }

    fun showOrHideSoftKeyboard(isShow: Boolean) {
        showOrHideSoftKeyboard(isShow, commentEditText, InputMethodManager.SHOW_IMPLICIT)
    }

    fun showOrHideSoftKeyboard(isShow: Boolean, view: View, showMode: Int) {
        val imm = view.context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
        if (isShow) {
            view.isFocusable = true
            view.isFocusableInTouchMode = true
            view.requestFocus()
            imm.showSoftInput(view, showMode)
            commentLayout.visibility = View.VISIBLE
        } else {
            imm.hideSoftInputFromWindow(view.windowToken, 0)
            commentLayout.visibility = View.GONE
        }
    }

    override fun showProgressDialog() {
        if (UiUtils.isActivityStateValid(activity) && activity is BaseActivity) {
            (activity as BaseActivity).showProgressDialog("")
        }
    }

    override fun hideProgressDialog() {
        if (UiUtils.isActivityStateValid(activity) && activity is BaseActivity) {
            (activity as BaseActivity).dismissProgressDialog()
        }
    }

    private fun startAddYiai() {
        val loginExtService = LoginExtServiceImpl()
        loginExtService.preLoginWithDialog(activity) { status ->
            if (status == LoginExtService.LOGIN_SUCC) {
                baseActivity?.showProgressDialog("")
                mJoinAiyiPresenter.joinAiyi()
            }
        }
    }

    private fun startLeaveYiai() {
        val loginExtService = LoginExtServiceImpl()
        loginExtService.preLoginWithDialog(activity) { status ->
            if (status == LoginExtService.LOGIN_SUCC) {
                baseActivity?.showProgressDialog("")
                mJoinAiyiPresenter.leaveAiyi()
            }
        }
    }

    override fun clickPublishDiscuss() {
        if (mPresenter?.defaultAreaId != 0L) {
            UTFacade.buttonClickWithoutPage("PublishBtnClick", "source", "3", "type", "1")
            LoginHelper.preLoginWithDialog(activity) { status ->
                when (status) {
                    LoginExtService.LOGIN_SUCC -> NavigatorUtil.gotoAddDiscuss(context, null, mPresenter?.defaultAreaId, null, null)
                    else -> {
                    }
                }
            }
        }

    }

    override fun clickPublishQusetion() {
        if (mPresenter?.defaultAreaId != 0L) {
            UTFacade.buttonClickWithoutPage("PublishBtnClick", "source", "3", "type", "2")
            LoginHelper.preLoginWithDialog(activity) { status ->
                when (status) {
                    LoginExtService.LOGIN_SUCC -> NavigatorUtil.gotoAddQuestion(context, null, null, mPresenter?.defaultAreaId)
                    else -> {
                    }
                }
            }
        }
    }


    override fun showCommunityData(communityHomepageVO: CommunityHomepageVO?, isRefresh: Boolean) {
        stateHelper.showState(CoreState.STATE)
        removeLoadingItem()
        if (communityHomepageVO == null) {
            return
        }
        if (isRefresh) {
            adapter.clearItems()
            aiyiItem?.onClear()
            setTitleBarRightButton()
            if (communityHomepageVO.yilianClub != null) {
                if (aiyiItem == null) {
                    aiyiItem = CommunityAiyiItem(communityHomepageVO.yilianClub, this).apply {
                        aiyiItem = this
                        promotionShowFestival = communityHomepageVO.promotionShowFestival?.apply {
                            if (!DataUtil.isNullOrEmpty(shows)) {
                                while (shows.size < 8) {
                                    shows = shows.plus(shows)
                                }
                            }
                        }
                    }
                } else {
                    aiyiItem?.apply {
                        promotionShowFestival = communityHomepageVO.promotionShowFestival?.apply {
                            if (!DataUtil.isNullOrEmpty(shows)) {
                                while (shows.size < 8) {
                                    shows = shows.plus(shows)
                                }
                            }
                        }
                        updateData(communityHomepageVO.yilianClub)
                    }
                }
                adapter.addItem(aiyiItem, true)
            }
            if (communityHomepageVO.artShowTabs != null) {
                adapter.addItem(CommunityShowAndSoonContainerItem(communityHomepageVO, this), true)
            }

            if (communityHomepageVO.communityFilmHall != null) {
                adapter.addItem(CommunityFilmHallItem(communityHomepageVO.communityFilmHall, this), true)
            }

            if (communityHomepageVO.showFestivals.isNotEmpty()) {
                adapter.addItem(CommunityFestivalContainerItem(communityHomepageVO.showFestivals, this), true)
            }
            showWelcomeAiyiDialog()
            addCommunityFeedItem(communityHomepageVO?.communityFeedList)
        } else {
            //load more
            addCommunityFeedItem(communityHomepageVO?.communityFeedList)
        }
        if (mPresenter.hasMore()) {
            updateLoadingItem(false)
        }


    }

    override fun addCommentSuccess(communityCommentMainTabModel: CommunityCommentMainTabModel?) {
        if (commentFeedCardModel != null && communityCommentMainTabModel != null) {
            val mainTabCommentMainTabModel = CommunityCommentMainTabModel()
            mainTabCommentMainTabModel.content = communityCommentMainTabModel.content
            mainTabCommentMainTabModel.userVO = communityCommentMainTabModel.userVO
            var index = 0
            for (it in adapter.mData) {
                if (it is CommunityFeedBaseItem && it.data is CommunityFeedCardModel
                        && TextUtils.equals((it.data as CommunityFeedCardModel).id, commentFeedCardModel?.id)) {
                    it.addComment(communityCommentMainTabModel)
                    break
                }
                index++
            }
        }
        commentEditText.clearFocus()
        commentEditText.setText("")
        showOrHideSoftKeyboard(false)
    }


    private fun addCommunityFeedItem(communityFeedList: MutableList<CommunityFeedCardModel>?) {
        if (communityFeedList.isNullOrEmpty()) {
            return
        }
        if (adapter.indexOfItem(CommunityFeedBaseItem::class.java) < 0) {
            adapter.addItem(CommunityFeedColumnTitleItem("今日精选"), true)
        }
        for (it in communityFeedList) {
            when (it.columnType) {
                COMMUNITY_FEED_ACTIVITY -> adapter.addItem(CommunityFeedArticleItem(it, this), true)
                COMMUNITY_FEED_ANOTHER_ACTIVITY -> adapter.addItem(CommunityFeedArticleItem(it, this), true)
                COMMUNITY_FEED_INFORMATION -> adapter.addItem(CommunityFeedArticleItem(it, this), true)
                COMMUNITY_FEED_PREVIEW_MOVIE -> adapter.addItem(CommunityFeedVideoItem(it, mVideoCommunityManager, this), true)
                COMMUNITY_FEED_TALK_FILM -> adapter.addItem(CommunityFeedDiscussionItem(it, mSixPicRecycledViewPool, this), true)
                COMMUNITY_FEED_OPTION -> adapter.addItem(CommunityFeedBattleItem(it, this), true)
            }
        }
    }

    private fun addMyDiscussCard(communityFeedCardModel: CommunityFeedCardModel?) {
        if (communityFeedCardModel == null || adapter == null) {
            return
        }

        if (adapter.indexOfItem(CommunityFeedBaseItem::class.java) < 0) {
            adapter.addItem(CommunityFeedColumnTitleItem("今日精选"), true)
        }

        adapter.findItems(CommunityFeedDiscussionItem::class.java)?.filter { it?.data?.isLocalFeedData == true }?.forEach {
            adapter.removeItem(it, true)
        }
        adapter.addItem(getHeadDataCount() + 1, CommunityFeedDiscussionItem(communityFeedCardModel, mSixPicRecycledViewPool, this), true)
        recyclerView.scrollToPosition(getHeadDataCount())
        adapter.notifyDataSetChanged()
    }

    private val listener = View.OnClickListener {
        updateLoadingItem(false)
        mPresenter.loadData(false)
    }

    private fun updateLoadingItem(isError: Boolean) {
        if (loadingItem == null || adapter == null) {
            return
        }
        val notifyIndex = adapter.indexOfItem(loadingItem)
        if (notifyIndex < 0) {
            adapter.addItem(loadingItem, true)
        }
        if (isError) {
            loadingItem.showErrorStatus()
        } else {
            loadingItem.showLoadingStatus()
        }
    }

    override fun onEvent(eventId: Int, mo: Any?, extObject: Any?): Boolean {
        if (eventId == ItemEvent.EVENT_ID_COMMUNITY_AIYI_ADD) {
            if (mPresenter.isAddAiyi) {
                startLeaveYiai()
            } else {
                startAddYiai()
            }
        } else if (eventId == ItemEvent.EVENT_ID_HOME_UPCOMING_PAGE_SOON_SHOW_MORE_CLICK) {
            if (mo is ShowMo) {
                checkSession {
                    mFarvorPresenter.changeFilmWantStatus(mo)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_HOME_PAGE_SHOW_ITEM_CLICK) {
            if (mo is ShowMo) {
                jumpToFilmInfoPage(mo)
            }
        } else if (eventId == ItemEvent.EVENT_ID_COMMUNITY_GO_FILM_CALENDAR) {
            //艺术电影
            var jumpUrl = if (extObject is String) {
                "tbmovie://taobao.com/filmcalendar?${CommunityFilmCalendarFragment.KEY_PAGE_FROM}=$extObject"
            } else {
                "tbmovie://taobao.com/filmcalendar"
            }
            MovieNavigator.handleUrl(activity, jumpUrl)

        } else if (eventId == ItemEvent.EVENT_ID_HOME_PAGE_SHOW_ITEM_BUY_CLICK) {
            if (mo is ShowMo) {
                onBuyClick(mo)
            }
        } else if (eventId == ItemEvent.EVENT_ID_COMMUNITY_FILM_FESTIVAL_ITEM_CLICK) {
            if (mo is FilmFestivalVO) {
                MovieNavigator.handleUrl(activity, mo.jumpUrl)
            }
        } else if (eventId == ItemEvent.EVENT_ID_COMMUNITY_FILM_FESTIVAL_MORE_CLICK) {
            FilmFestivalIndexActivity.gotoFilmFestivalIndexActivity(context, FilmFestivalIndexFragment.PAGE_FROM_FESTIVAL_MORE)
        } else if (eventId == ItemEvent.EVENT_ID_COMMUNITY_INPUT_CLICK) {
            showOrHideSoftKeyboard(true)
            if (mo is CommunityFeedCardModel) {
                commentFeedCardModel = mo
                mScrollY = mo.scrollY
            }
        } else if (eventId == DiscussItemEvents.GOTO_PICTURE_PREVIEW_CLICK) {
            if (mo is DiscussionMo) {
                MovieNavigator.handleUrl(context, mo.jumpUrl)
            }
        }
        return true
    }

    override fun joinAiyiSuccess(yilianClubVO: YilianClubVO?) {
        baseActivity?.dismissProgressDialog()
        if (yilianClubVO == null) {
            return
        }
        mPresenter.updateAiyiClubMo(yilianClubVO)
        setTitleBarRightButton()
        var aiyiItemList = adapter.findItems(CommunityAiyiItem::class.java)
        aiyiItemList?.forEach {
            it.updateData(yilianClubVO)
            it.refreshItem()
        }
        ToastUtil.showToast("加入成功，你是No." + yilianClubVO.userRank + "爱艺青年")


    }

    private fun initAiyiDialog(): Unit {
        var lastTime = MovieCacheSet.getInstance().getLong(SHOW_AIYI_TIME_SP_KEY, 0)
        hasShowWelcomeAiyi = ServerTime.getCurrentServerTime() - lastTime < 7 * 24 * 3600 * 1000
    }

    private fun showWelcomeAiyiDialog() {
        if (hasShowWelcomeAiyi || !LoginHelper.checkSessionValid() || mPresenter.yilianClubVO == null || mPresenter.isAddAiyi) {
            return
        }
        //保护 java.lang.IllegalStateException: Can not perform this action after onSaveInstanceState
        try {
            var welcomeToJoinAiyiDialog = WelcomeToJoinAiyiDialog()
            welcomeToJoinAiyiDialog.setOnItemEventListener(this, mPresenter.yilianClubVO)
            var bundle = Bundle()
            welcomeToJoinAiyiDialog.arguments = bundle
            welcomeToJoinAiyiDialog.show(fragmentManager, "WelcomeToJoinAiyiDialog")
            hasShowWelcomeAiyi = true
            MovieCacheSet.getInstance().putLong(SHOW_AIYI_TIME_SP_KEY, ServerTime.getCurrentServerTime())
        } catch (e : Exception) {

        }
    }

    override fun joinAiyiFailed(errorMsg: String?) {
        baseActivity?.dismissProgressDialog()
        if (!errorMsg.isNullOrEmpty()) {
            ToastUtil.showToast(errorMsg)
        }
    }

    override fun leaveAiyiSuccess(yilianClubVO: YilianClubVO?) {
        baseActivity?.dismissProgressDialog()
        if (yilianClubVO == null) {
            return
        }
        mPresenter.updateAiyiClubMo(yilianClubVO)
        setTitleBarRightButton()
        var aiyiItemList = adapter.findItems(CommunityAiyiItem::class.java)
        aiyiItemList?.forEach {
            it.updateData(yilianClubVO)
            it.refreshItem()
        }

    }

    override fun leaveAiyiFailed(errorMsg: String?) {
        baseActivity?.dismissProgressDialog()
        if (!errorMsg.isNullOrEmpty()) {
            ToastUtil.showToast(errorMsg)
        }
    }


    override fun onFavoriteChange(movieID: String?, favorite: Boolean, currentStars: Int?, userShowStatus: Int) {
        if (adapter != null && adapter.indexOfItem(CommunityShowAndSoonContainerItem::class.java) > -1) {
            val item = adapter.getItem(adapter.indexOfItem(CommunityShowAndSoonContainerItem::class.java)) as CommunityShowAndSoonContainerItem
            item.changeFavor(movieID, currentStars, userShowStatus)
        }
    }

    override fun updateFavorStatue(id: String?, isFavor: Boolean, favorCount: Int?, userShowStatus: Int) {
    }

    override fun doFilmFavorStart() {
        if (UiUtils.isActivityStateValid(baseActivity)) {
            baseActivity.showProgressDialog("", true)
        }
    }

    override fun doFilmFavorFinish() {
        if (UiUtils.isActivityStateValid(baseActivity)) {
            baseActivity.dismissProgressDialog()
        }
    }

    override fun showWantedTip(isUpcoming: Boolean, showResultIndexMo: ShowResultIndexMo?, id: String?) {
        if (UiUtils.isActivityStateValid(baseActivity)) {
            WantedTipUtil(baseActivity).showWantedTip(true, showResultIndexMo, id)
        }
    }

    private fun jumpToFilmInfoPage(showMo: ShowMo?) {
        if (showMo == null) {
            return
        }
        showMo?.let {
            MovieNavigator.gotoAction(this, IntentConstants.Action.ACTION_SHOWDETAIL, Bundle().apply {
                putBoolean(IntentConstants.KEY_SHOWING, true)
                putString(IntentConstants.KEY_SHOWID, showMo.id)
                putString(UTConstants.sqm, SqmKeeper.SQM_COMMUNITY)

            })
        }
    }

    private fun onBuyClick(showMo: ShowMo?) {
        if (showMo == null) {
            return
        }

        if (TextUtils.equals(showMo.soldType, ShowMo.SOLD_TYPE_VOD)) {
            NavigatorUtil.gotoVideoList(activity, showMo.id)
            return
        }
        val bundle = Bundle()
        bundle.putString(IntentConstants.KEY_OSCAR_MOVIE_ID, showMo.id)
        bundle.putString(IntentConstants.KEY_OSCAR_MOVIE_NAME, showMo.showName)
        bundle.putString(UTConstants.sqm, SqmKeeper.SQM_COMMUNITY)

        MovieNavigator.gotoAction(this, IntentConstants.Action.ACTION_CINEMALIST, bundle)
    }

    fun doDoubleClick() {
        recyclerView?.scrollToPosition(0)
    }

    override fun onLoadMore(): Boolean {
        var status = mPresenter.loadData(false)
        val notifyIndex = adapter.indexOfItem(loadingItem)
        if (notifyIndex >= 0) {
            loadingItem.showLoadingStatus()
        }
        return status
    }

    private fun removeLoadingItem() {
        if (loadingItem != null && adapter != null) {
            val notifyIndex = adapter.indexOfItem(loadingItem)
            if (notifyIndex >= 0) {
                adapter.removeItem(loadingItem)
                adapter.notifyItemRemoved(notifyIndex)
            }
        }
    }

    override fun showEmpty() {
        refreshFinished()
        var hasContent = adapter.getCount(CommunityAiyiItem::class.java, CommunityShowAndSoonContainerItem::class.java, CommunityFestivalContainerItem::class.java, CommunityFeedBaseItem::class.java) > 0
        if (adapter != null && !hasContent) {
            stateHelper.showState(SimpleProperty(EmptyState.STATE).setHint("暂无内容")
                    .setButtonVisiable(true)
                    .setImgResId(R.drawable.common_empty_view)
                    .setTopHolderHeight(48))
        }
    }

    override fun showError(isToast: Boolean, resultCode: Int, returnCode: Int, returnMsg: String?) {
        var hasContent = false
        hasContent = adapter.getCount(CommunityAiyiItem::class.java, CommunityShowAndSoonContainerItem::class.java, CommunityFestivalContainerItem::class.java, CommunityFeedBaseItem::class.java) > 0
        if (hasContent) {
            updateLoadingItem(true)
        }
        super.showError(hasContent, resultCode, returnCode, returnMsg)

    }

    private fun getHeadDataCount(): Int {
        return adapter.getCount(CommunityAiyiItem::class.java, CommunityShowAndSoonContainerItem::class.java, CommunityFestivalContainerItem::class.java)
    }

    private fun getAllDataCount(): Int {
        return adapter.getCount(CommunityAiyiItem::class.java, CommunityShowAndSoonContainerItem::class.java, CommunityFestivalContainerItem::class.java, CommunityFeedBaseItem::class.java)
    }

    fun onEventMainThread(event: TppNativeToWxNotifyEvent) {
        if (event?.localDiscussMo?.id == null || event?.localDiscussMo?.discussionAreaId != mPresenter?.defaultAreaId) {
            return
        }
        if (getAllDataCount() == 0) {
            return
        }
        addMyDiscussCard(covertFromDiscussMo(event?.localDiscussMo)?.apply { isLocalFeedData = true })
    }

    fun onEventMainThread(event: TabChangeEvent?) {
        if (event == null || event.to == null || event.from == null) {
            return
        }
        if (event.to !== event.from) {
            if (TextUtils.equals(MovieTabMoProvider.TAB_ACTION_COMMUNITY, event.from.tabAction)) {
                if (mVideoCommunityManager != null) {
                    mVideoCommunityManager.setHomeTabSelected(false)
                }
                aiyiItem?.onPageDisAppear()
            } else if (TextUtils.equals(MovieTabMoProvider.TAB_ACTION_COMMUNITY, event.to.tabAction)) {
                mVideoCommunityManager.setHomeTabSelected(true)
                aiyiItem?.onPageAppear()
            }
        }
    }

    override fun onDestroy() {
        FavoriteManager.getInstance().unRegisterDefault(this)
        EventBus.getDefault().unregister(this)
        super.onDestroy()
    }

    override fun onDestroyView() {
        super.onDestroyView()
        if (mVideoCommunityManager != null) {
            mVideoCommunityManager.onActivityDestroy()
        }
        LocalBroadcastManager.getInstance(activity!!).unregisterReceiver(cityChangeBroadcastReceiver)

    }

    override fun onStop() {
        super.onStop()
        if (mVideoCommunityManager != null) {
            mVideoCommunityManager.onActivityStop()
        }
    }

    override fun onPause() {
        super.onPause()
        if (mVideoCommunityManager != null) {
            mVideoCommunityManager.onActivityPause()
        }
        aiyiItem?.onPause()
    }

    override fun onResume() {
        super.onResume()
        if (mVideoCommunityManager != null) {
            mVideoCommunityManager.onActivityResume()
        }
        aiyiItem?.onResume()
    }

    override fun onPageSelect(bundle: Bundle?) {
    }

}
