package com.taobao.movie.android.app.oscar.ui.community.view

import android.view.View
import android.widget.TextView
import com.taobao.listitem.recycle.CustomRecyclerViewHolder
import com.taobao.listitem.recycle.RecyclerExtDataItem
import com.taobao.movie.android.common.item.theme.ItemEvent
import com.taobao.movie.android.commonui.widget.shapebuilder.ShapeBuilder
import com.taobao.movie.android.component.R
import com.taobao.movie.appinfo.util.DisplayUtil
import com.taobao.movie.appinfo.util.ResHelper

/**
 * 社区电影节查看更多
 */
class CommunityFestivalMoreItem(count: Int?, listener: OnItemEventListener<*>?) : RecyclerExtDataItem<CommunityFestivalMoreItem.ViewHolder, Int>(count, listener), View.OnClickListener {

    override fun onBindViewHolder(viewHolder: ViewHolder) {

        viewHolder.moreTitle.text = "查看全部"
        viewHolder.itemView.setOnClickListener(this)
        ShapeBuilder.create().radius(DisplayUtil.dp2px(6f)).solid(ResHelper.getColor(R.color.deliver_not_select)).build(viewHolder.view)
    }

    override fun onClick(v: View?) {
        when (v) {
            viewHolder.itemView -> {
                onEvent(ItemEvent.EVENT_ID_COMMUNITY_FILM_FESTIVAL_MORE_CLICK)
            }
        }
    }

    override fun getLayoutId(): Int {
        return R.layout.oscar_community_festival_more_item
    }

    class ViewHolder(itemView: View) : CustomRecyclerViewHolder<CommunityFestivalMoreItem>(itemView) {
        var view: View
        var moreTitle: TextView


        init {
            view = itemView.findViewById(R.id.rl_show_more_item)
            moreTitle = itemView.findViewById<View>(R.id.tv_homepage_show_more_title) as TextView
        }
    }
}
