package com.taobao.movie.android.app.oscar.ui.homepage.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import com.taobao.movie.android.app.oscar.ui.homepage.fragment.FeedTypeFavorFragment
import com.taobao.movie.android.commonui.component.BaseToolBarActivity
import com.taobao.movie.android.commonui.utils.ImmersionStatusBar
import com.taobao.movie.android.commonui.widget.MTitleBar
import com.taobao.movie.android.commonui.widget.MToolBar
import com.taobao.movie.android.home.R

class MyFavorActivity :BaseToolBarActivity() {

    private lateinit var toolbar: MToolBar

    companion object {
        fun gotoFavorActivity(context: Context?) {
            if(context == null) {
                return
            }
            context.startActivity(Intent(context,MyFavorActivity::class.java))
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        ImmersionStatusBar.setupWindow(window)
        ImmersionStatusBar.statusBarDark(this, true)
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_my_favor)
        initToolbar()
        if (savedInstanceState == null) {
            supportFragmentManager.beginTransaction().add(R.id.fl_content,FeedTypeFavorFragment()).commitAllowingStateLoss()
        }
    }

    protected fun initToolbar() {
        toolbar = findViewById(R.id.toolbar)
        toolbar.setType(MToolBar.IMMERSION)
        setSupportActionBar(toolbar)
    }


    override fun initTitleBar(titleBar: MTitleBar?) {
        titleBar?.setTitle("我关注的")
        titleBar?.setLeftButtonText(getString(R.string.icon_font_titlebar_back))
        titleBar?.setLeftButtonListener { onBackPressed() }
        titleBar?.setLineVisable(true)
    }
}