package com.taobao.movie.android.app.oscar.ui.homepage.fragment

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.graphics.Rect
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.support.v4.content.LocalBroadcastManager
import android.support.v7.widget.RecyclerView
import android.support.v7.widget.StaggeredGridLayoutManager
import android.text.TextUtils
import android.view.View
import android.view.ViewGroup
import com.taobao.listitem.recycle.PreLoadAdapter
import com.taobao.listitem.recycle.RecyclerDataItem
import com.taobao.listitem.recycle.RecyclerExtDataItem
import com.taobao.movie.android.app.abtest.ABTestConfigProvider
import com.taobao.movie.android.app.common.abtask.ABTestViewModel
import com.taobao.movie.android.app.common.abtask.model.ABTestResponseModel
import com.taobao.movie.android.app.home.activity.ThematicPagesActivity
import com.taobao.movie.android.app.home.recycleitem.HomeScrollAdItem
import com.taobao.movie.android.app.home.init.HomeItemPreload
import com.taobao.movie.android.app.home.tab.MovieTabMoProvider
import com.taobao.movie.android.app.home.tab.TabChangeEvent
import com.taobao.movie.android.app.oscar.biz.mtop.FeedDoubleRowListInfoResponseVo
import com.taobao.movie.android.app.oscar.ui.homepage.activity.MyFavorActivity.Companion.gotoFavorActivity
import com.taobao.movie.android.app.oscar.ui.homepage.behavior.MyHeaderBehavior
import com.taobao.movie.android.app.oscar.ui.homepage.item.HomeBreadBannerItem
import com.taobao.movie.android.app.oscar.ui.homepage.item.HomeFeedRecommendDividerItem
import com.taobao.movie.android.app.oscar.ui.homepage.item.HomeTopItem
import com.taobao.movie.android.app.oscar.ui.homepage.item.preview.MovieTrailerItem
import com.taobao.movie.android.app.oscar.ui.homepage.model.SubFragmentNotifyEvent
import com.taobao.movie.android.app.oscar.ui.homepage.tab.FeedTypeScrollModuleImpl
import com.taobao.movie.android.app.oscar.ui.smartvideo.fragment.VideoListVerticalFragment
import com.taobao.movie.android.app.oscar.ui.smartvideo.player.newplay.IYoukuViewController
import com.taobao.movie.android.app.oscar.ui.smartvideo.player.newplay.layer.MuteMobileNetResolutionLayer
import com.taobao.movie.android.app.presenter.article.AddFavorUnitePresenter
import com.taobao.movie.android.app.presenter.collect.ContentCollectPresenter
import com.taobao.movie.android.app.presenter.feed.FeedBusinessPresenter
import com.taobao.movie.android.app.presenter.feed.FeedRecommendPresenter
import com.taobao.movie.android.app.presenter.feed.FeedReportReportPresenter
import com.taobao.movie.android.app.presenter.feedback.FeedbackSubmitPresenter
import com.taobao.movie.android.app.presenter.video.VideoReportPresenter
import com.taobao.movie.android.app.ui.article.helper.FeedItemAddHelper
import com.taobao.movie.android.app.ui.article.helper.UpdateArticleCommentHelper
import com.taobao.movie.android.app.ui.common.WantedTipUtil
import com.taobao.movie.android.app.ui.fadeback.FeedbackUTUtils
import com.taobao.movie.android.app.ui.fadeback.NegativeFeedBackPop
import com.taobao.movie.android.app.video.FilmEnterItem.FILM_ENTER_FOR_RESULT_CODE
import com.taobao.movie.android.app.video.videoplaymanager.VideoFeedPreviewManager
import com.taobao.movie.android.app.vinterface.article.IAddFavorView
import com.taobao.movie.android.app.vinterface.collect.IContentCollectView
import com.taobao.movie.android.app.vinterface.feed.IFeedDoubleRowView
import com.taobao.movie.android.app.vinterface.feedback.IFeedbackSubmitView
import com.taobao.movie.android.arch.obtainViewModel
import com.taobao.movie.android.common.IntentConstants
import com.taobao.movie.android.common.Region.RegionExtServiceImpl
import com.taobao.movie.android.common.item.feed.FeedBaseNewItem
import com.taobao.movie.android.common.item.feed.FeedFilmShowCardItem
import com.taobao.movie.android.common.item.feed.FeedMaintenanceItem
import com.taobao.movie.android.common.item.feed.FeedVideoItem
import com.taobao.movie.android.common.item.feed.errorStatus.FeedInfoCommonErrorState
import com.taobao.movie.android.common.item.feed.errorStatus.FeedInfoEmptyState
import com.taobao.movie.android.common.item.feed.errorStatus.FeedInfoLoadingState
import com.taobao.movie.android.common.item.feed.errorStatus.FeedInfoNetErrorState
import com.taobao.movie.android.common.item.homepage.HomePageShowAndSoonContainerItem
import com.taobao.movie.android.common.item.homepage.HomepagePerformanceContainerItem
import com.taobao.movie.android.common.item.homepage.HomepageShowContainerBaseItem
import com.taobao.movie.android.common.item.theme.ItemEvent
import com.taobao.movie.android.common.login.LoginHelper
import com.taobao.movie.android.common.login.checkSession
import com.taobao.movie.android.common.scheme.MovieNavigator
import com.taobao.movie.android.commonui.component.IPageSelectable
import com.taobao.movie.android.commonui.component.lcee.ILceeView
import com.taobao.movie.android.commonui.component.lcee.MultiPresenters
import com.taobao.movie.android.commonui.component.lcee.RefreshView
import com.taobao.movie.android.commonui.component.lcee.ScrollableView
import com.taobao.movie.android.commonui.recyclerview.LoadingItem
import com.taobao.movie.android.commonui.utils.UiUtils
import com.taobao.movie.android.commonui.widget.FavoriteManager
import com.taobao.movie.android.commonui.widget.FavoriteManager.notifyFavorite
import com.taobao.movie.android.commonui.widget.shapebuilder.ShapeBuilder
import com.taobao.movie.android.home.R
import com.taobao.movie.android.integration.CommonConstants
import com.taobao.movie.android.integration.common.service.LoginExtService
import com.taobao.movie.android.integration.common.service.RegionExtService
import com.taobao.movie.android.integration.feedback.model.FeedbackItemModel
import com.taobao.movie.android.integration.feedback.model.FeedbackOverallModel
import com.taobao.movie.android.integration.oscar.model.FavorAndCommentMo
import com.taobao.movie.android.integration.oscar.model.FeedDataModel
import com.taobao.movie.android.integration.oscar.model.ReportPlayMo
import com.taobao.movie.android.integration.oscar.model.SmartVideoMo
import com.taobao.movie.android.integration.oscar.model.db.MovieFeedDbHelper
import com.taobao.movie.android.integration.oscar.uiInfo.HomepageVO
import com.taobao.movie.android.sdk.infrastructure.monitor.MonitorErrorCode
import com.taobao.movie.android.sdk.infrastructure.monitor.MovieAppMonitor
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTFacade
import com.taobao.movie.android.video.model.IVideoUType
import com.taobao.movie.android.video.model.MVideoConfigCache
import com.taobao.movie.android.video.report.ReportVideoUtils
import com.taobao.movie.appinfo.util.*
import com.taobao.movie.shawshank.ShawshankResponse
import com.taobao.movie.statemanager.state.CoreState
import de.greenrobot.event.EventBus
import io.reactivex.disposables.CompositeDisposable
import movie.taobao.com.videocache.manager.VideoPreloadManager
import java.util.*

/**
 * 首页双列feed流 Fragment
 * 新版本会全量替换
 */
class FeedTypeDoubleRowRecommandFragment : FeedListBaseFragment(), IAddFavorView<FavorAndCommentMo>,
        IFeedbackSubmitView, IContentCollectView, IFeedDoubleRowView, IRefreshFeedPage, IPageSelectable,
        RecyclerExtDataItem.OnItemEventListener<Any>, MyHeaderBehavior.OnNestScrollChangedListener,
        MyHeaderBehavior.OnNestedScrollStateListener, RefreshView, ScrollableView, notifyFavorite, IYoukuViewController.IPlayReportListener {
    override fun setRefreshData(data: Any?) {
        if (data is HomepageVO) {
            this.homepageVO = data
        }
    }

    override fun onViewRefresh(refresh: Boolean) {
        adapter?.let {
            addHomeListPageItem()
        }
        adapter?.notifyDataSetChanged()
        if (TextUtils.equals(cityCode,RegionExtServiceImpl().userRegion.cityCode)) {
            onRefresh(refresh)
        } else {
            cityCode = RegionExtServiceImpl().userRegion.cityCode
        }
    }

    /*-----------------810新增负反馈内容--start---------------*/
    private val negativeFeedBackPop by lazy(LazyThreadSafetyMode.NONE) {
        NegativeFeedBackPop(this.activity).apply {
            setRelateView(recyclerView)
            setOnBtnClickListener(NegativeFeedBackPop.IOnBtnClickListener { needSubmit, submitModel ->
                if (submitModel == null) {
                    return@IOnBtnClickListener
                }
                //UT埋点
                if (DataUtil.isNullOrEmpty(submitModel.feedbackItems)) {
                    FeedbackUTUtils.utAnchorNegativeFeedbackNoInterestBtn(this@FeedTypeDoubleRowRecommandFragment)
                } else {
                    FeedbackUTUtils.utAnchorNegativeFeedbackConfirmBtn(this@FeedTypeDoubleRowRecommandFragment)
                }
                if (needSubmit) {
                    submitFeedBackInfo(submitModel)//提交
                } else {//如果不需要提交则直接移除对应条目
                    val list = ArrayList<FeedbackOverallModel>()
                    list.add(submitModel)
                    showFeedbackSubmitSucess(list)
                }
            })
        }
    }

    private var mCompositeDisposable: CompositeDisposable = CompositeDisposable()
    private val wantedTipUtil: WantedTipUtil? = null
    private var cacheResponse: FeedDoubleRowListInfoResponseVo? = null
    private var isSelecting = false
    var mUserVisibleHint = false
    private var mOnPageSelectedFlag = false
    private var hasResponseScenary = false
    private var topDataSize = 0
    private val abTestViewModel by lazy(LazyThreadSafetyMode.NONE) {
        obtainViewModel(ABTestViewModel::class.java)
    }

    private var homepageVO: HomepageVO? = null
    private var homeTopItem: HomeTopItem? = null
    /* 滑动状态 */
    private var scrollState = 0
    //记录城市id
    private var cityCode: String? = null
    private var  mVideoFeedPreviewManager : VideoFeedPreviewManager? = null
    private var homeScrollAdItem: HomeScrollAdItem? = null


    /**
     * H5页面片单收藏成功
     * 当已登陆未收藏场景下：，然后点击条目进入h5详情页，则此时回来到该页面，应该更新对应的状态
     */
    var billboardCollectChangeReceiver: BroadcastReceiver = object : BroadcastReceiver() {

        override fun onReceive(context: Context, intent: Intent) {
            try {
                val id = intent.getStringExtra("id")//对应关注对象的id
                val type = intent.getStringExtra("type")//对应关注对象的类型为，片单为：2
                val isCollect = TextUtils.equals("ADD", intent.getStringExtra("operation"))
                if (TextUtils.equals("2", type)) {
                    updateFeedBillBoardCollectStatus(id, isCollect)
                }
            } catch (e: Throwable) {
                LogUtil.e("FeedTypeRecommendFragment", e.toString())
            }

        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        EventBus.getDefault().register(this)
        FavoriteManager.getInstance().registerDefault(this)
        cityCode = RegionExtServiceImpl().userRegion.cityCode
        //缓存逻辑标记，935暂时不需要
//        FeedInfoCacheHelper.getInstance().setLoadSuccessListener { responseVo -> cacheResponse = responseVo }
    }

    override fun onResume() {
        super.onResume()
        mVideoFeedPreviewManager?.onActivityResume()
    }

    override fun onPause() {
        super.onPause()
        mVideoFeedPreviewManager?.onActivityPause()
    }

    override fun initViewContent(layoutView: View, savedInstanceState: Bundle?) {
        super.initViewContent(layoutView, savedInstanceState)
        mVideoFeedPreviewManager = VideoFeedPreviewManager()
        mVideoFeedPreviewManager?.setVideoRecyclerView(recyclerView, adapter)
        mVideoFeedPreviewManager?.setCurrentTabSelect(mUserVisibleHint)
        layoutView.setBackgroundResource(R.color.common_text_color15)
        val bgView = layoutView.findViewById<View>(R.id.background_view)
        bgView.visibility = View.VISIBLE
        ShapeBuilder.create().gradient(ResHelper.getColor(R.color.white),
                ResHelper.getColor(R.color.common_text_color15),
                ResHelper.getColor(R.color.common_text_color15)).
                build(bgView)
        //注册H5页面收藏榜单的消息监听
        LocalBroadcastManager.getInstance(activity!!)
                .registerReceiver(billboardCollectChangeReceiver, IntentFilter(IntentConstants.KEY_ACTION_UPDATE_COLLECTION))
        showFeedLoadingView(FeedBusinessPresenter.PAGE_FEEDTYPE_RECOMMOD, false)
        if (mOnPageSelectedFlag) {
            onInitiatedPageSelected()
            mOnPageSelectedFlag = false
        }
        isSelecting = true
        recyclerView.addOnScrollListener(mOnScrollListener)
        recyclerView.addItemDecoration(object : RecyclerView.ItemDecoration() {

            private val itemSpace = DisplayUtil.dp2pxInt(9f) //item间隔
            private val itemSpaceMiddle = DisplayUtil.dp2pxInt(4.5f)
            private val itemSpaceSide = DisplayUtil.dp2pxInt(15f) //item间隔
            private val itemSpaceTopSide = DisplayUtil.dp2pxInt(12f)

            override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State) {
                super.getItemOffsets(outRect, view, parent, state)
                val pos = parent.getChildLayoutPosition(view)
                val lp = view.layoutParams as StaggeredGridLayoutManager.LayoutParams
                if (adapter.getItem(pos) is FeedBaseNewItem) {
                    if (pos == 0 || pos == 1) {
                        outRect.top = itemSpaceTopSide
                    } else {
                        outRect.top = itemSpace
                    }

                    if (lp.spanIndex % 2 == 0) { //行的第一个
                        outRect.left = itemSpaceSide
                        outRect.right = itemSpaceMiddle
                    }  else {
                        outRect.left = itemSpaceMiddle
                        outRect.right = itemSpaceSide
                    }
                }
            }
        })
        addModule(FeedTypeScrollModuleImpl(this, recyclerView), ScrollableView::class.java)
        preLoadItem()
    }

    private fun preLoadItem(){
        HomeItemPreload.getInstance().clearHomeItemPreload()
        HomeItemPreload.getInstance().clearHomeShowItemPreload()
        val preLoadAdapter = PreLoadAdapter.HolderHelper.fetchAdapter(HomePageListFragment::class.java, false)
        if (preLoadAdapter != null) {
            val recycledViewPool = preLoadAdapter.viewPool
            if (recycledViewPool != null) {
                val codes = arrayOf(HomePageShowAndSoonContainerItem::class.java.hashCode(), HomepagePerformanceContainerItem::class.java.hashCode(),HomeBreadBannerItem::class.java.hashCode())
                for(code in codes){
                    var recycledViewHolder = recycledViewPool.getRecycledView(code)
                    recycledViewHolder?.let {
                        if (recycledViewHolder is HomepageShowContainerBaseItem.ViewHolder) {
                            recycledViewHolder.updateViewPool()
                        }
                        var layoutParams = StaggeredGridLayoutManager.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT)
                        layoutParams.isFullSpan = true
                        recycledViewHolder.itemView.layoutParams= layoutParams
                        recycledViewPool.putRecycledView(recycledViewHolder)
                    }
                }
                recyclerView.setRecycledViewPool(recycledViewPool)
            }
        }
    }

    override fun setHeadBehavior(behavior: MyHeaderBehavior<*>?) {
        super.setHeadBehavior(behavior)
        if (behavior != null) {
            behavior.addOnNestScrollChangedListener(this)
            behavior.addOnNestedScrollStateListener(this)
        }
    }

    override fun onNestedPreScroll(dx: Int, dy: Int, type: Int) {
        if (mUserVisibleHint && !hasResponseScenary) {
            if (recyclerView.getLocalVisibleRect(Rect()) ) {
                abTestViewModel.reachABTestScenario("index_feed_entrance",onSuccess = {
                    ABTestConfigProvider.getProvider().updateScenarioParams(it.scenario,it.params)
                })
                hasResponseScenary = true
            }
        }
    }

    override fun onStopNestedScroll(type: Int) {
    }

    override fun onStateChange(state: Int) {
        if (state == MyHeaderBehavior.SCROLL_STATE_IDLE) {
            playGifAndPreloadVideo()
        }
    }

    private fun playGifAndPreloadVideo() {
        if (adapter == null) {
            return
        }
        var preloadList = arrayListOf<String>()
        var layoutManager = recyclerView.layoutManager as StaggeredGridLayoutManager
        val firstArray = layoutManager.findFirstVisibleItemPositions(null)
        val lastArray = layoutManager.findLastVisibleItemPositions(null)
        var startIndex = if (firstArray[0] > firstArray[1]) firstArray[1] else firstArray[0]
        val endIndex = if (lastArray[0] > lastArray[1]) lastArray[0] else lastArray[1]
        while (startIndex <= endIndex) {
            val feedItem = adapter.getItem(startIndex)
            if (feedItem is FeedBaseNewItem) {
                val imageView = feedItem.getFeedCardImageView()
                if (feedItem is FeedVideoItem && feedItem.data?.convertToVideoMode() != null) {
                    var preloadUrl = MVideoConfigCache.getInstance().getPlayUrlByGlobalDefinition(feedItem.data?.convertToVideoMode())
                    preloadList.add(preloadUrl)
                }
                var localRect: Rect
                if (imageView == null) {
                    startIndex++
                    continue
                }
                imageView.getLocalVisibleRect(Rect().also { localRect = it })
                if (imageView.isGif || imageView.isWebp) {
                    if (Math.abs(localRect.top - localRect.bottom) >= imageView.height) {
                        imageView.start()
                    } else {
                        imageView.stop()
                    }
                }
            }
            startIndex++
        }
        VideoPreloadManager.getInstance().preDownload(preloadList)
    }

    private fun stopPlayGif() {
        if(adapter == null) {
            return
        }
        for (it in adapter.mData) {
            if (it is FeedBaseNewItem && it.getFeedCardImageView() != null
                    && ( it.getFeedCardImageView().isWebp || it.getFeedCardImageView().isGif)) {
                it.getFeedCardImageView().stop()
            }
        }
    }

    override fun initLayoutManager(): RecyclerView.LayoutManager {
        return StaggeredGridLayoutManager(2, StaggeredGridLayoutManager.VERTICAL)
    }

    override fun setUserVisibleHint(userVisibleHint: Boolean) {
        super.setUserVisibleHint(userVisibleHint)
        mUserVisibleHint = userVisibleHint
        mVideoFeedPreviewManager?.setCurrentTabSelect(mUserVisibleHint)
        if (getParentFragment() is HomePageListFragment) {
            (getParentFragment() as HomePageListFragment).childFeedUserVisibleChanged(!userVisibleHint)
        }
        if (mUserVisibleHint) {
            if (UiUtils.isFragmentStateValid(this) && !TextUtils.equals(cityCode, RegionExtServiceImpl().userRegion.cityCode)) {//切换城市
                this.onViewRefresh(true)
            }
            if (presenter != null && adapter != null && !hasFeedDataItem()) {
                onInitiatedPageSelected()
            } else {
                mOnPageSelectedFlag = true
            }
            if (!hasFeedDataItem()) {
                addMaintenanceItem(FeedInfoLoadingState.STATE)
            }
            playGifAndPreloadVideo()
        } else {
            stopPlayGif()
        }
    }


    override fun onRefresh(pullToRefresh: Boolean): Boolean {
//        if (pullToRefresh) {
//            onUTButtonClick("HomePagePullDownRefresh")
//        }
        requestFeedInfoData(CommonConstants.RequestType.PullDownRefresh)
        return false
    }

    private fun onInitiatedPageSelected() {
        notifyHomePageListIndicatorRefreshing(CommonConstants.RequestType.PullDownRefresh)
        onRefresh(false)
    }

    override fun createPresenter(): MultiPresenters<ILceeView> = MultiPresenters(FeedRecommendPresenter(FeedBusinessPresenter.PAGE_FEEDTYPE_RECOMMOD),
            AddFavorUnitePresenter<IAddFavorView<FavorAndCommentMo>, FavorAndCommentMo>(CommonConstants.PAGE_HOME_PAGE), FeedReportReportPresenter(),
            FeedbackSubmitPresenter(), VideoReportPresenter(), ContentCollectPresenter())

    override fun onRefreshClick() {
        onRefresh(false)
    }

    override fun onLoginStatusChanged() {

    }

    override fun updateFavorStatus(onSuccess: Boolean, favorAndCommentMo: FavorAndCommentMo, isFavor: Boolean, favorCount: Int) {
        UpdateArticleCommentHelper.updataFeedFavor(adapter, onSuccess, favorAndCommentMo, isFavor, favorCount)
    }

    override fun showAddFavorError(isToast: Boolean, resultCode: Int, returnCode: Int, returnMsg: String) {
        handleStateError(true, resultCode, returnCode, returnMsg)
    }

    override fun showFeedError(pageFeedType: Int, refreshType: String, resultCode: Int, returnCode: Int, returnMsg: String) {
        stateHelper.showState(CoreState.STATE)
        addHomeListPageItem()
        notifyHomePageListIndicatorRefreshOver(refreshType, true)
        handleFeedListError(resultCode, returnCode, returnMsg, refreshType)
    }

    override fun showFeedEmpty(pageFeedType: Int, refreshType: String) {
        if (pageFeedType == FeedBusinessPresenter.PAGE_FEEDTYPE_RECOMMOD) {
            onUTButtonClick("FeedsResponseEmpty", "isListEmpty",
                    if (adapter != null && adapter.getCountByBaseItem(FeedBaseNewItem::class.java) > 0) "1" else "0", "refreshType", refreshType,
                    "use_on_page_name", "1")
        }
        addHomeListPageItem()
        notifyHomePageListIndicatorRefreshOver(refreshType, true)
        if (!hasFeedDataItem()) {
            if (!cacheResponse?.feedData.isNullOrEmpty() ||
                    !cacheResponse?.topData.isNullOrEmpty()) {
                showFeedContentView(FeedBusinessPresenter.PAGE_FEEDTYPE_RECOMMOD, true, cacheResponse,
                        CommonConstants.RequestType.PullUpRefresh)
            } else {
                addMaintenanceItem(FeedInfoEmptyState.STATE)
            }
        } else {
            val tip = "暂时没有新内容啦"
            when (refreshType) {
                CommonConstants.RequestType.ClickItemToRefresh -> ToastUtil.showToast(tip)
                CommonConstants.RequestType.ClickTitleToRefresh -> ToastUtil.showToast(tip)
                CommonConstants.RequestType.ClickTipToRefresh -> {
                    if (hasFeedDataItem()) {
                        ToastUtil.showToast(tip)
                    }
                }
                CommonConstants.RequestType.PullUpRefresh -> ToastUtil.showToast(tip)
            }
            removeMaintenanceItem()
            removeLoadingItem()
        }
    }

    override fun showFeedLoadingView(pageFeedType: Int, hasData: Boolean) {
        if(adapter.mData.size == 0) {
            addHomeListPageItem()
        }
        stateHelper.showState(CoreState.STATE)
        if (!hasFeedDataItem() && mUserVisibleHint) {
            addMaintenanceItem(FeedInfoLoadingState.STATE)
        }
    }

    override fun addMaintenanceItem(state: String?) {
        if (adapter == null) {
            return
        }
        removeLoadingItem()
        mMaintenanceItem.showStatus(state)
        var maintenanceItemHeight = layoutView.measuredHeight
//        if (maintenanceItemHeight == 0) {
//            layoutView.measure(0, 0)
//            maintenanceItemHeight = layoutView.measuredHeight
//        }
        if (adapter.indexOfItem(mMaintenanceItem) < 0) {
            adapter.addItem(mMaintenanceItem, true)
        }
        if (maintenanceItemHeight < DisplayUtil.dp2px(324f)) {
            mMaintenanceItem.shrank(DisplayUtil.getDisplayHeightInPx()
                    -(DisplayUtil.getActionBarHeight(context)+DisplayUtil.getStatusBarHeight()+DisplayUtil.getNavigationBarHeight()+DisplayUtil.dp2pxInt(55f)))
        } else {
            mMaintenanceItem.shrank(maintenanceItemHeight)
        }
        mMaintenanceItem.refreshItem()
    }

    override fun showFeedContentView(pageFeedType: Int, isCacheData: Boolean, data: FeedDoubleRowListInfoResponseVo?, refreshType: String) {
        if (data != null) {
            stateHelper.showState(CoreState.STATE)
            notifyHomePageListIndicatorRefreshOver(refreshType, true)
            showFeedContentView(pageFeedType, isCacheData, data.feedData, data.topData, refreshType)
            removeMaintenanceItem()
            recyclerView.postDelayed({
                playGifAndPreloadVideo()
            }, 500)
        }
    }

    private fun showFeedContentView(pageFeedType: Int, isCacheData: Boolean, feeds: ArrayList<FeedDataModel>?, topFeeds: ArrayList<FeedDataModel>?, refreshType: String) {
        if (!TextUtils.equals(CommonConstants.RequestType.PullUpRefresh, refreshType)) {
            adapter.removeItem(FeedBaseNewItem::class.java,true)
            adapter.removeItem(FeedMaintenanceItem::class.java,true)
            adapter.removeItem(LoadingItem::class.java,true)
        }
        topDataSize = if (topFeeds.isNullOrEmpty()) 0 else topFeeds.size
        addTopFeedItemToAdapter(topFeeds)
        addNormalFeedItemToAdapter(feeds, refreshType, isCacheData)
        recyclerView.requestLayout()//bug fix,当点击负反馈按钮remove条目时，此时下页数据返回，添加之后，导致UI不会更新

        if (getFeedListPresenter().hasMore()) {
            addLoadingItem()
        } else {
            removeLoadingItem()
        }
        if (!TextUtils.equals(CommonConstants.RequestType.PullUpRefresh, refreshType)) {
            //视频预加载逻辑
            var preloadList = arrayListOf<String>()
            var startIndex: Int = 0
//            val count = adapter.getCount(FeedBaseNewItem::class.java)
            val count = adapter.itemCount
            var minEnd = Math.min(count,8)
            if (count < 0 || startIndex > count) {
                return
            }
            for (index in startIndex until minEnd) {
                val feedItem = adapter.getItem(index)
                if (feedItem is FeedVideoItem && feedItem.data?.convertToVideoMode() != null) {
                    var preloadUrl = MVideoConfigCache.getInstance().getPlayUrlByGlobalDefinition(feedItem.data?.convertToVideoMode())
                    preloadList.add(preloadUrl)
                }
            }
            VideoPreloadManager.getInstance().preDownload(preloadList)
        }

    }

    /**
     * RecyclerView 滑动状态监听
     */
    private val mOnScrollListener: RecyclerView.OnScrollListener = object : RecyclerView.OnScrollListener() {
        override fun onScrollStateChanged(recyclerView: RecyclerView, newState: Int) {
            scrollState = newState
            if (newState == RecyclerView.SCROLL_STATE_IDLE && getParentFragment() is HomePageListFragment) {
                (getParentFragment() as HomePageListFragment).scrollEnd()
                playGifAndPreloadVideo()
            }
        }

        override fun onScrolled(recyclerView: RecyclerView, dx: Int, dy: Int) {
            if ((scrollState == RecyclerView.SCROLL_STATE_DRAGGING || scrollState == RecyclerView.SCROLL_STATE_SETTLING)
                    && getParentFragment() is HomePageListFragment) {
                (getParentFragment() as HomePageListFragment).scrollStart(dy)
            }
            if (userVisibleHint && !hasResponseScenary && scrollState == RecyclerView.SCROLL_STATE_DRAGGING) {
                val layoutManager = recyclerView.layoutManager as StaggeredGridLayoutManager
                if (layoutManager.findLastVisibleItemPositions(null)[0] == adapter.indexOfItem(FeedBaseNewItem::class.java)) {
                    abTestViewModel.reachABTestScenario("index_feed_entrance", { abTestResponseModel: ABTestResponseModel? ->
                        if (UiUtils.isFragmentStateValid(this@FeedTypeDoubleRowRecommandFragment)
                            && abTestResponseModel != null && abTestResponseModel.params != null
                            && TextUtils.equals(abTestResponseModel.scenario, "index_feed_entrance")) {
                            ABTestConfigProvider.getProvider().updateScenarioParams(abTestResponseModel.scenario, abTestResponseModel.params)
                        }
                    })
                    hasResponseScenary = true
                }
            }

            when (homeScrollAdItem?.canScroll()) {
                true -> {
                    homeScrollAdItem?.scrollAd(recyclerView.layoutManager?.height ?: 0)
                }
            }
        }
    }


    private fun addHomeListPageItem() {
        val fragment = getParentFragment()
        if (fragment is HomePageListFragment) {
            val homeFragment = fragment
            homeTopItem = homeFragment.addTopModule(homepageVO, adapter, this)
            homeFragment.loadWeexMoudle(homepageVO!!, adapter)
            homeFragment.addShowAndSoonModule(homepageVO, adapter)
            homeFragment.addBreadBannerModule(homepageVO, recyclerView, adapter)
            homeFragment.addHappyCoinModule(homepageVO, adapter)
            homepageVO?.apply { addMovieTrailerItem(this) }
            homeFragment.addPerformanceModule(homepageVO, adapter)
            homeFragment.addShowAlbumModule(homepageVO, adapter)
            homeFragment.addRecyclerScrollStateListener(recyclerView)
            homeScrollAdItem = homeFragment.addScrollAdModule(homepageVO,adapter)
            homeTopItem?.let{
                recyclerView.addOnChildAttachStateChangeListener(it)
                recyclerView.addOnScrollListener(it.onScrollListener)
                it.setHomeTopVisibleCallback { it.isHomeTopItemVisible(recyclerView) }
            }
            showFeedRecommendDivider()
        }
    }

    private fun addMovieTrailerItem(homepageVO: HomepageVO) {
        /*run{
            //mock
            homepageVO.previewsPlayModuleVO = PreviewsPlayModuleVO().apply {
                this.title = "xixihaha"
                this.rankType = RankTypesCategoryMo().apply {
                    rankListH5Url = "https://h5.m.taopiaopiao.com/app/movie/pages/show-rank-list/index.html?needCity=YES&type=14"
                    rankName = "热播预告TOP10"
                    type = "14"
                }
                this.shows = mutableListOf(ShowMo().apply {
                    showName = "叶问4：完结篇"
                    scoreAndFavor = ScoreAndFavor().apply {
                        score = ScoreDetail().apply {
                            score = 9.2
                            scoreCount = 645237
                            scoreCountDesc = "64.5万 人评"
                            scoreName="淘票票评分"
                            scoreType = 1
                        }
                    }
                    id = "214159"
                    openDay = "2019-12-20 00:00:00"
                    openTime = "2019-12-20"
                    poster = "i2/TB1hEqQq4n1gK0jSZKPXXXvUXXa_.jpg"
                    preScheduleRemarkCount = 0
                    remark = 9.2
                    remarkCount = 645237
                    userShowStatus = 0
                    wantCount = 1426065
                }, ShowMo().apply {
                    id = "1295988"
                    openDay = "2020-03-06 00:00:00"
                    openTime = "2020-03-06"
                    poster = "i2/TB1Rf4JtAL0gK0jSZFtXXXQCXXa_.jpg"
                    preScheduleRemarkCount = 0
                    remarkCount = 0
                    scoreAndFavor = ScoreAndFavor().apply {
                        favorCount = 15188
                        favorCountDesc = "1.5万 人想看"
                        score = ScoreDetail().apply {
                            scoreName = "暂无评分"
                            scoreType = 1
                        }
                    }
                    showName = "月半爱丽丝"
                    userShowStatus = 0
                    wantCount = 15188
                })
            }
        }*/
        if (homepageVO.previewsPlayModuleVO == null) {
            adapter.removeItem(MovieTrailerItem::class.java)
        } else {
            val index = adapter.indexOfItem(MovieTrailerItem::class.java)
            if (index < 0) {
                MovieTrailerItem(homepageVO.previewsPlayModuleVO, mVideoFeedPreviewManager, this, this).apply {
                    adapter.addItem(adapter.getCount(HomeTopItem::class.java, HomePageShowAndSoonContainerItem::class.java, HomeBreadBannerItem::class.java), this, true)
                }
            } else {
                val item = adapter.getItem(index)
                if (item is MovieTrailerItem) {
                    item.updateData(homepageVO.previewsPlayModuleVO)
                    adapter.notifyItemChanged(index)
                }
            }
        }
    }

    fun handleStateError(isToast: Boolean, resultCode: Int, returnCode: Int, returnMsg: String) {
        if (isToast) {
            val toashString: String?
            if (returnCode == 280001) {
                toashString = null
            } else if (resultCode == ShawshankResponse.RESULT_CODE_NETWORK) {
                toashString = getString(R.string.statemanager_network_error)
            } else {
                toashString = returnMsg
            }
            if (!TextUtils.isEmpty(toashString)) {
                ToastUtil.showToast(toashString!!)
            }
        } else {
            when (resultCode) {
                ShawshankResponse.RESULT_CODE_NETWORK -> addMaintenanceItem(FeedInfoNetErrorState.STATE)
                ShawshankResponse.RESULT_CODE_LOGIN_CANCELED -> addMaintenanceItem(FeedInfoCommonErrorState.STATE)
                else -> addMaintenanceItem(FeedInfoCommonErrorState.STATE)
            }
        }
    }

    override fun onPageSelect(switchType: Int, bundle: Bundle?) {
        isSelecting = true
        if (!hasFeedDataItem()) {
            notifyHomePageListIndicatorRefreshOver(CommonConstants.RequestType.PullDownRefresh, false)
        } else {
            notifyHomePageListIndicatorRefreshOver(CommonConstants.RequestType.PullDownRefresh, true)
        }
        //如果选中时数据没有则需要加载数据
        if (adapter != null && adapter.itemCount <= 0) {
            onRefresh(false)
        }
    }

    override fun onPageDisSelect(switchType: Int, bundle: Bundle?) {
        isSelecting = false
    }

    override fun notifyHomePageListIndicatorRefreshing(refreshType: String) {
        notifyHomePageListIndicatorRefreshState(refreshType, SubFragmentNotifyEvent.TYPE_NOTIFY_REFRESH_REFRESHING, true)
    }

    override fun notifyHomePageListIndicatorRefreshOver(refreshType: String, needShowRefreshZone: Boolean) {
        notifyHomePageListIndicatorRefreshState(refreshType, SubFragmentNotifyEvent.TYPE_NOTIFY_REFRESH_OVER, needShowRefreshZone)
    }

    protected fun handleFeedListError(resultCode: Int, returnCode: Int, returnMsg: String?, refreshType: String) {
        if (CommonConstants.RequestType.ClickItemToRefresh == refreshType || CommonConstants.RequestType.ClickTitleToRefresh ==
                refreshType || CommonConstants.RequestType.ClickTipToRefresh == refreshType && hasFeedDataItem()) {
            val toastString: String?
            toastString = if (returnCode == 280001) {
                null
            } else if (resultCode == ShawshankResponse.RESULT_CODE_NETWORK) {
                getString(R.string.statemanager_network_error)
            } else {
                returnMsg
            }
            if (!TextUtils.isEmpty(toastString)) {
                ToastUtil.showToast(toastString!!)
            }
        }
        if (hasFeedDataItem()) {
            addLoadingErrorItem()
            removeMaintenanceItem()
            if (returnCode == 280001) {
                addMaintenanceItem(returnMsg, CoreState.STATE)
                val startIndex = 0
                val endIndex = adapter.indexOfItem(FeedMaintenanceItem::class.java)
                for (index in endIndex - 1 downTo startIndex) {
                    adapter.removeItem(index, true)
                }
            }
        } else {
            if (returnCode == 280001) {
                addMaintenanceItem(returnMsg, CoreState.STATE)
            } else {
                if (!cacheResponse?.feedData.isNullOrEmpty() ||
                        !cacheResponse?.topData.isNullOrEmpty()) {
                    showFeedContentView(FeedBusinessPresenter.PAGE_FEEDTYPE_RECOMMOD, true, cacheResponse,
                            CommonConstants.RequestType.PullUpRefresh)
                } else {
                    if (resultCode == ShawshankResponse.RESULT_CODE_NETWORK) {
                        addMaintenanceItem(FeedInfoNetErrorState.STATE)
                    } else {
                        addMaintenanceItem(FeedInfoCommonErrorState.STATE)
                    }
                }
            }
        }
        if (resultCode != ShawshankResponse.RESULT_CODE_NETWORK && resultCode != ShawshankResponse.RESULT_CODE_LOGIN_CANCELED) {
            MovieAppMonitor.commitFail(MonitorErrorCode.TPP_PORTAL_NO_ARTICLE_LIST_ERROR,
                    RegionExtServiceImpl().userRegion.cityCode + " ,resultCode" + resultCode + " ,returnCode" + returnCode)
        }
    }

    override fun notifyHomePageListIndicatorRefreshState(refreshType: String, notifyTYpe: String, needShowRefreshZone: Boolean) {
        val event = SubFragmentNotifyEvent()
        event.pageFlag = mCurrentPageFeedType
        event.requestType = refreshType
        event.needShowRefreshZone = needShowRefreshZone
        event.notifyType = notifyTYpe
        event.post()
    }

    private fun hasFeedDataItem(): Boolean {
        if (adapter == null) {
            return false
        }
        val index = adapter.indexOfItem(FeedBaseNewItem::class.java)
        return index >= 0
    }

    override fun onLoadMore(): Boolean {
        if (adapter.indexOfItem(FeedMaintenanceItem::class.java) > 0) {
            return false
        }
        getFeedListPresenter().hasMore = true
        return getFeedListPresenter().doLoadMore()
    }

    /**
     * @des 添加普通feed流数据，包括横向的推荐大号数据
     */
    private fun addNormalFeedItemToAdapter(feedData: ArrayList<FeedDataModel>?, refreshType: String, isCacheData: Boolean) {
        if (!feedData.isNullOrEmpty()) {
            if (CommonConstants.RequestType.PullUpRefresh != refreshType) {
                val firstIndex = (recyclerView.layoutManager as StaggeredGridLayoutManager).findFirstCompletelyVisibleItemPositions(null)[0]
                if (firstIndex == 0) {
                    recyclerScrollToTop()
                }
                if (!isCacheData) {
                    showRefreshTips(feedData.size)
                }
            }
            addFeedItemToAdapter(feedData)
        }
    }

    private fun addTopFeedItemToAdapter(feedData: ArrayList<FeedDataModel>?) {
        if(feedData.isNullOrEmpty()) {
            return
        }
        for (it in feedData) {
            it.localIsTopData = true
        }
        addFeedItemToAdapter(feedData)
    }

    private fun addFeedItemToAdapter(feedData: ArrayList<FeedDataModel>?) {
        if (adapter == null || feedData.isNullOrEmpty()) {
            return
        }
        for (it in feedData) {
            it.feed_page = "1"
            val feedBaseItem = FeedItemAddHelper.getFeedItemByFeedInfo(it, this)
            if (feedBaseItem != null) {
                //广告item老版本的特殊处理
                if (it.innerType == FeedDataModel.FeedType.AD) {
                    MovieCacheSet.getInstance().putBoolean(FeedBusinessPresenter.getNeedClearLastIdCacheKey(), true)
                }
                feedBaseItem.localUTIndex = adapter.itemCount + 1
                adapter.addItem(feedBaseItem, true)
            }
        }

    }

    //显示刷新的条目数
    private fun showRefreshTips(count: Int) {
        if (isSelecting) {
            notifyHomePageListShowTip(count)
        }
    }

    override fun onStop() {
        super.onStop()
        if (negativeFeedBackPop.isShowing) {
            negativeFeedBackPop.dismiss()
        }
    }

    private fun requestFeedInfoData(type: String) {
        getFeedListPresenter().requestData(type)
    }

    private fun getFeedListPresenter(): FeedRecommendPresenter {
        if (presenter == null) {
            presenter = createPresenter()
            presenter.attachView(this)
        }
        return presenter.findPresenter<FeedRecommendPresenter>(FeedRecommendPresenter::class.java) as FeedRecommendPresenter
    }


    //提交反馈信息
    private fun submitFeedBackInfo(submitModel: FeedbackOverallModel?) {
        val feedbackSubmitPresenter = findFeedbackSubmitPresenter()
        if (submitModel == null || feedbackSubmitPresenter == null) {
            return
        }
        feedbackSubmitPresenter.submitFeedbackInfo(submitModel)
    }

    override fun onPreFeedbackSubmitExcute() {
        negativeFeedBackPop.updateFeedbackPopState(NegativeFeedBackPop.FEEDBACK_POP_STATE_SUBMITTING)
    }

    override fun showFeedbackSubmitSucess(feedbackOverallModels: List<FeedbackOverallModel>?) {
        ToastUtil.showToast(getString(R.string.feedback_submit_response_success))
        if (feedbackOverallModels == null || feedbackOverallModels.size <= 0) {
            return
        }
        val feedbackOverallModel = feedbackOverallModels[0]
        if (negativeFeedBackPop.isShowing) {
            negativeFeedBackPop.dismiss(feedbackOverallModel)
        }
        removeFeedItemByModel(feedbackOverallModel)//移除对应Item
        MovieFeedDbHelper.getHelper().dbFeedInfoModelDao.deleteByKey(feedbackOverallModel.Local_DB_ID)

    }

    override fun showFeedbackSubmitFail(feedbackOverallModels: List<FeedbackOverallModel>?, returnMessage: String) {
        ToastUtil.showToast(getString(R.string.feedback_submit_response_fail))

        var feedbackOverallModel: FeedbackOverallModel? = null
        if (feedbackOverallModels != null) {
            feedbackOverallModel = feedbackOverallModels[0]
        }
        if (feedbackOverallModel == null) {
            return
        }
        if (negativeFeedBackPop.isShowing) {
            negativeFeedBackPop.dismiss(feedbackOverallModel)
        }
    }

    private fun removeFeedItemByModel(feedbackOverallModel: FeedbackOverallModel?) {
        if (feedbackOverallModel == null) {
            return
        }

        var needRemovedItemIndex = -1
        var needRemoveItem: RecyclerDataItem<*, *>? = null
        for (index in adapter.itemCount - 1 downTo 0) {
            val item = adapter.getItem(index)

            if (item?.data is FeedDataModel) {
                val feedInfoModel = item.data as FeedDataModel
                if (TextUtils.equals(feedInfoModel.id, feedbackOverallModel.feedId) && TextUtils.equals(feedInfoModel.innerId,
                                feedbackOverallModel.innerId) && feedInfoModel.time == feedbackOverallModel.time) {
                    needRemovedItemIndex = index
                    needRemoveItem = item
                    break
                }
            }
        }

        if (needRemovedItemIndex >= 0) {
            adapter.removeItem(needRemovedItemIndex, true)
        }
    }

    private fun findFeedbackSubmitPresenter(): FeedbackSubmitPresenter? {
        if (presenter == null) {
            presenter = createPresenter()
            presenter.attachView(this)
        }
        return presenter.findPresenter<FeedbackSubmitPresenter>(FeedbackSubmitPresenter::class.java) as FeedbackSubmitPresenter
    }

    override fun onCityChangedFromParent() {
        if (recyclerView != null) {
            recyclerView.scrollToPosition(0)
        }
    }

    override fun scrollToTop() {
        getModule(ScrollableView::class.java)?.apply { scrollToTop() }
    }

    val handler = Handler(Looper.getMainLooper())
    fun scrollToFeed() {
        if (recyclerView != null) {
            var index = adapter.indexOfItem(HomeFeedRecommendDividerItem::class.java)
            recyclerView.scrollToPosition(index)
            adapter.getItem(index).apply {
                handler.post { recyclerView.smoothScrollBy(0, recycleViewHolder?.itemView?.top ?: 0) }
            }
        }
    }

    override fun onLoginChangedFromParent() {
        if (recyclerView != null) {
            recyclerView.scrollToPosition(0)
        }
        if (UiUtils.isFragmentStateValid(this@FeedTypeDoubleRowRecommandFragment)) {
            onRefresh(false)
        }
    }

    /**
     * @des 更新数据接口，在HomePageListFragment中有调用 会有下拉刷新和点击indicator中的刷新按钮刷新
     */
    override fun onRefreshPageFromParent(pageType: Int, refreshType: String) {
        if (this.isDetached) {
            return
        }
        requestFeedInfoData(refreshType)
    }

    override fun onEvent(eventId: Int, data: Any?, extObject: Any?): Boolean {
        if (eventId == ItemEvent.EVENT_ID_BILLBOARD_FAVOR_CLICK) {//feed流中片单的收藏点击
            if (data is FeedDataModel) {
                val collectStatus = data.collectStatus
                checkSession {
                    changeBillboardCollectStatus(data.innerId, collectStatus)
                }
            }
        } else if (eventId == ItemEvent.ARTICLE_EVENT_ID_SHOWDETAIL) { //文章
            if (data is FeedDataModel) {
                if (!TextUtils.isEmpty(data.jumpUrl)) {
                    MovieNavigator.handleUrl(getActivity(), data.jumpUrl)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_HOT_CARD_ITEM_CLICK) { //热门卡片
            if (data is FeedDataModel) {
                gotoHotTopicDetailActivity(data.innerId)
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_FILM_SHOW_ITEM_CLICK) { //片单
            if (data is FeedDataModel) {
                if (!TextUtils.isEmpty(data.jumpUrl)) {
                    MovieNavigator.handleUrl(getActivity(), data.jumpUrl)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_SUBJECT_ITEM_CLICK) { //专题
            if (data is FeedDataModel) {
                if (!TextUtils.isEmpty(data.jumpUrl)) {
                    MovieNavigator.handleUrl(getActivity(), data.jumpUrl)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_BILLBORAD_ITEM_CLICK) { //榜单
            if (data is FeedDataModel) {
                if (!TextUtils.isEmpty(data.jumpUrl)) {
                    MovieNavigator.handleUrl(getActivity(), data.jumpUrl)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_VIDEO_ITEM_CLICK) { //视频
            if (data is FeedDataModel) {
                if (data.verticalVideo) {
                    gotoVerticalVideo(data.convertToVideoMode(), extObject)
                } else {
                    gotoImmerseVideo(data.convertToVideoMode(), extObject)
                }

            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_INFO_ITEM_CLOSE_FEEDBACK) {//-点击关闭条目
            FeedbackUTUtils.utAnchorNegativeFeedbackButton(this@FeedTypeDoubleRowRecommandFragment)//UT埋点
            var needJudgedFeedInfoItemModel: FeedDataModel? = null
            if (data is FeedDataModel && extObject is View) {
                needJudgedFeedInfoItemModel = data//记录将要被判定是否移除的Item对应的Model，用来负反馈点击确定后移除该条目
                val feedBackPop = negativeFeedBackPop;

                //构建对应的负反馈所需的模型信息
                val submitModel = FeedbackOverallModel()
                submitModel.feedId = needJudgedFeedInfoItemModel.id
                submitModel.innerId = needJudgedFeedInfoItemModel.innerId
                submitModel.innerType = needJudgedFeedInfoItemModel.innerType
                submitModel.time = needJudgedFeedInfoItemModel.time
                if (needJudgedFeedInfoItemModel.negativeFeedbackItemList == null) {
                    submitModel.feedbackItems = ArrayList<FeedbackItemModel>()
                } else {
                    submitModel.feedbackItems = ArrayList<FeedbackItemModel>(needJudgedFeedInfoItemModel.negativeFeedbackItemList)
                }
                feedBackPop.with(submitModel).show(extObject)
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_ASSCIATED_CLICK) { //点击关联影片
            if (data is FeedDataModel && data.showVO != null) {
                val bundle = Bundle()
                bundle.putSerializable(IntentConstants.KEY_SHOW_MO, data.showVO)
                MovieNavigator.gotoActionForResult(activity, IntentConstants.Action.ACTION_SHOWDETAIL, bundle,
                        FILM_ENTER_FOR_RESULT_CODE)
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_MEDIA_ICON_CLICK) { //媒体号头像点击
            if (data is FeedDataModel && data.media != null) {
                if (!TextUtils.isEmpty(data.media.url)) {
                    MovieNavigator.handleUrl(context, data.media.url)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_ADDFAVOR) { //媒体号头像点击
            if (data is FeedDataModel) {
                val favorType = DataUtil.getIntNumberFromString(data.favorType)
                val addFavorPresenter = presenter.findPresenter<AddFavorUnitePresenter<*, FeedDataModel>>(AddFavorUnitePresenter::class.java) as AddFavorUnitePresenter<*, FeedDataModel>
                if (addFavorPresenter != null) {
                    return addFavorPresenter.addFavor(data, favorType)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_SUBJECT_ITEM_CLICK) { //专题
            if (data is FeedDataModel) {
                if (!TextUtils.isEmpty(data.jumpUrl)) {
                    MovieNavigator.handleUrl(getActivity(), data.jumpUrl)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_FEED_AD_ITEM_CLICK) { //广告
            if (data is FeedDataModel) {
                if (!TextUtils.isEmpty(data.jumpUrl)) {
                    MovieNavigator.handleUrl(getActivity(), data.jumpUrl)
                }
            }
        } else if (eventId == ItemEvent.EVENT_ID_COMMUNITY_BUSINESS_PREVIEW_VIDEO_CLICK) {
            if (data is SmartVideoMo) {
                val bundle = Bundle()
                bundle.putSerializable(IntentConstants.KEY_VIDEO_MODEL, data)
                if (extObject is String && MuteMobileNetResolutionLayer.VALUE_RESOLUTION_AUTO_PLAY_4G_FIRST ==
                        extObject) {
                    bundle.putString(MuteMobileNetResolutionLayer.KEY_CLICK_RESOLUTION_AUTO_PLAY_4G_FIRST,
                            MuteMobileNetResolutionLayer.VALUE_RESOLUTION_AUTO_PLAY_4G_FIRST)
                }
                bundle.putString(IntentConstants.KEY_SHOWID, data.showId)
                bundle.putString(IntentConstants.KEY_VIDEOID, data.id)
                MovieNavigator.gotoAction(context, IntentConstants.Action.ACTION_FILM_VIDEO, bundle)
            }
        }
        return true
    }

    /**
     * 去热点卡片
     */
    private fun gotoHotTopicDetailActivity(trendingCardId: String?) {
        if (TextUtils.isEmpty(trendingCardId)) {
            return
        }
        val bundle = Bundle()
        bundle.putString("trendingCardId", trendingCardId)
        val intent = Intent(context, ThematicPagesActivity::class.java)
        intent.putExtras(bundle)
        startActivity(intent)
    }

    /**
     * 竖版视频页面
     */
    private fun gotoVerticalVideo(smartVideoMo: SmartVideoMo?, extObject: Any?) {
        if (smartVideoMo == null || TextUtils.isEmpty(smartVideoMo.id)) {
            return
        }
        var bundle = Bundle()
        if (extObject is String && MuteMobileNetResolutionLayer.VALUE_RESOLUTION_AUTO_PLAY_4G_FIRST == extObject) {
            //对应4G下点击流量框，到下个页面自动播放的场景
            bundle.putString(MuteMobileNetResolutionLayer.KEY_CLICK_RESOLUTION_AUTO_PLAY_4G_FIRST,
                    MuteMobileNetResolutionLayer.VALUE_RESOLUTION_AUTO_PLAY_4G_FIRST)
        }
        bundle.putSerializable(VideoListVerticalFragment.KEY_MSG_VIDEO_ID, smartVideoMo.id)
        bundle.putInt(VideoListVerticalFragment.KEY_PAGE_FROM, VideoListVerticalFragment.PAGE_FROM_MSG)
        MovieNavigator.gotoAction(activity, IntentConstants.Action.ACTION_PORTRAIL_VIDEO, bundle)

    }

    /**
     * 沉浸页
     */
    private fun gotoImmerseVideo(smartVideoMo: SmartVideoMo?, extObj: Any?) {
        if (smartVideoMo == null || TextUtils.isEmpty(smartVideoMo.id)) {
            return
        }
        var bundle = Bundle()
        if (extObj is String && MuteMobileNetResolutionLayer.VALUE_RESOLUTION_AUTO_PLAY_4G_FIRST == extObj) {
            //对应4G下点击流量框，到下个页面自动播放的场景
            bundle.putString(MuteMobileNetResolutionLayer.KEY_CLICK_RESOLUTION_AUTO_PLAY_4G_FIRST,
                    MuteMobileNetResolutionLayer.VALUE_RESOLUTION_AUTO_PLAY_4G_FIRST)
        }
        bundle.putSerializable(IntentConstants.KEY_VIDEO_MODEL, smartVideoMo)
        MovieNavigator.gotoAction(activity, IntentConstants.Action.ACTION_IMMERSE_VIDEO, bundle)
    }

    /**
     * 片单收藏状态改变
     *
     * @param id
     * @param currentStatus
     */
    private fun changeBillboardCollectStatus(id: String, currentStatus: Int) {
        if (presenter != null) {
            val contentCollectPresenter = presenter.findPresenter<ContentCollectPresenter>(ContentCollectPresenter::class.java) as ContentCollectPresenter
            if (currentStatus == 1) {//已关注状态
                contentCollectPresenter.unCollectBillboard(id)
            } else {
                contentCollectPresenter.collectBillboard(id)
            }
        }
    }

    /**
     * 片单收藏成功
     *
     * @param id
     */
    override fun onCollectSucess(id: String) {
        updateFeedBillBoardCollectStatus(id, true)
        ToastUtil.showToast(R.string.collect_sucess)
        UTFacade.buttonClickWithoutPage("CollectionStarClick", "id", id, "status", "1")
    }

    /**
     * 片单收藏失败
     *
     * @param id
     */
    override fun onCollectFail(id: String) {
        ToastUtil.showToast(R.string.collect_fail)
    }

    /**
     * 片单取消收藏成功
     *
     * @param id
     */
    override fun onUnCollectSucess(id: String) {
        updateFeedBillBoardCollectStatus(id, false)
        UTFacade.buttonClickWithoutPage("CollectionStarClick", "id", id, "status", "0")
        ToastUtil.showToast(R.string.uncollect_sucess)
    }

    /**
     * 片单取消收藏失败
     *
     * @param id
     */
    override fun onUnCollectFail(id: String) {
        ToastUtil.showToast(R.string.uncollect_fail)
    }

    fun setHomepageVO(homepageVO: HomepageVO): FeedTypeDoubleRowRecommandFragment {
        this.homepageVO = homepageVO
        return this
    }

    /**
     * 新鲜资讯
     */
    private fun showFeedRecommendDivider() {
        val index = adapter.indexOfItem(HomeFeedRecommendDividerItem::class.java)
        if (index < 0) {
            adapter.addItem(if (adapter.getCount(FeedMaintenanceItem::class.java) > 0) adapter.itemCount -1 else adapter.itemCount,HomeFeedRecommendDividerItem(Unit,RecyclerExtDataItem.OnItemEventListener<Any> {
                eventId, o, extObject ->
                gotoFavorActivity(context)
                false
            }))
        }
    }

    /**
     * 更新片单收藏状态
     *
     * @param id
     * @param isCollect
     */
    fun updateFeedBillBoardCollectStatus(id: String, isCollect: Boolean) {
        if (adapter == null) {
            return
        }
        for (index in 0..adapter.itemCount) {
            if (adapter.getItem(index) is FeedFilmShowCardItem) {
                val item = adapter.getItem(index) as FeedFilmShowCardItem
                if (item != null && item.data != null && TextUtils.equals(item.data.id, id)) {
                    item.updateCollectStatus(id, isCollect)
                }
            }
        }
    }

    override fun onDestroyView() {
        super.onDestroyView()
        EventBus.getDefault().unregister(this)
        //        FavoriteManager.getInstance().unRegisterDefault(this);
        LocalBroadcastManager.getInstance(activity!!).unregisterReceiver(billboardCollectChangeReceiver)
        if (mCompositeDisposable != null) {
            mCompositeDisposable.clear()
        }
        if (behavior != null) {
            behavior.removeOnNestScrollChangedListener(this)
        }
        FavoriteManager.getInstance().unRegisterDefault(this)
        mVideoFeedPreviewManager?.onActivityDestroy()
    }

    override fun onFavoriteChange(movieID: String?, favorite: Boolean, currentStars: Int?, userShowStatus: Int) {
        (getParentFragment() as? HomePageListFragment?)?.onFavoriteChange(adapter, movieID, currentStars, userShowStatus)
    }

    fun onEventMainThread(event: TabChangeEvent?) {
        if (event == null || event.to == null || event.from == null) {
            return
        }
        if (event.to !== event.from) {
            if (TextUtils.equals(MovieTabMoProvider.TAB_ACTION_HOME_PAGE, event.from.tabAction)) {
                mVideoFeedPreviewManager?.setHomeTabSelected(false)

            } else if (TextUtils.equals(MovieTabMoProvider.TAB_ACTION_HOME_PAGE, event.to.tabAction)) {
                mVideoFeedPreviewManager?.setHomeTabSelected(true)
            }
        }
    }

    override fun onStartPreloadVideo(currentPlayMo: SmartVideoMo?) {

    }

    override fun onReportPlay(mo: ReportPlayMo<*>?, currentData: SmartVideoMo?) {
        val regionExtService: RegionExtService<*> = RegionExtServiceImpl()
        mo?.cityCode = regionExtService.userRegion.cityCode
        (presenter.findPresenter<VideoReportPresenter>(VideoReportPresenter::class.java) as? VideoReportPresenter)?.reportPlay(mo)
    }

    override fun onUT(uType: IVideoUType?) {
        onUTButtonClick(uType?.name, *uType?.args)
    }

    override fun onReportVideo(reportVideoNewData: ReportVideoUtils.ReportVideoNewData?, currentData: SmartVideoMo?) {
        reportVideoNewData?.page = ReportVideoUtils.VideoPage.PLAYER_PAGE_FROM_FEED_PREVIEW.toString()
        reportVideoNewData?.spm_url = videoSpmWrapper?.spm_url
        reportVideoNewData?.spm_cnt = videoSpmWrapper?.spm_cnt
        ReportVideoUtils.reportVideoNew(reportVideoNewData, utPageName)
    }
}