package com.taobao.movie.android.app.oscar.ui.homepage.item

import android.support.v7.widget.StaggeredGridLayoutManager
import android.view.View
import android.widget.TextView
import com.taobao.listitem.recycle.CustomRecyclerViewHolder
import com.taobao.listitem.recycle.RecyclerExtDataItem
import com.taobao.movie.android.common.item.theme.ItemEvent
import com.taobao.movie.android.commonui.utils.RippleUtils
import com.taobao.movie.android.commonui.widget.shapebuilder.ShapeBuilder
import com.taobao.movie.android.home.R
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTFacade
import com.taobao.movie.appinfo.util.DisplayUtil
import com.taobao.movie.appinfo.util.ResHelper

/**
 * 新鲜资讯
 *
 * @author yidong.yyd
 * @since 2019-12-18
 */
class HomeFeedRecommendDividerItem(vo: Unit, listener: OnItemEventListener<*>?)
    : RecyclerExtDataItem<HomeFeedRecommendDividerItem.ViewHolder, Unit>(vo, listener) {
    override fun onBindViewHolder(vh: ViewHolder?) {
        vh?.entranceCombineLayout?.setOnClickListener {
            UTFacade.buttonClickWithoutPage("FollowingFeedClick")
            onEvent(ItemEvent.EVENT_ID_HOME_FEED_RECOMMEND_DIVIDER)
        }
    }

    override fun getLayoutId(): Int {
        return R.layout.oscar_home_recommend_divider_item_layout
    }

    class ViewHolder(itemView: View) : CustomRecyclerViewHolder<HomeFeedRecommendDividerItem>(itemView) {
        val entranceCombineLayout: View

        init {
            val textView: TextView = itemView.findViewById(R.id.tv_homepage_show_container_combine_entrance)
            textView.text = "我关注的"

            entranceCombineLayout = itemView.findViewById<View>(R.id.ll_homepage_show_container_combine_entrance)

            RippleUtils.setupRipple(entranceCombineLayout, ShapeBuilder.create()
                    .radius(DisplayUtil.dp2px(180f))
                    .solid(ResHelper.getColor(R.color.white))
                    .stroke(DisplayUtil.dp2pxInt(0.5f), ResHelper.getColor(R.color.common_image_bg_color))
                    .build())

            val layoutParams = itemView.layoutParams
            if (layoutParams is StaggeredGridLayoutManager.LayoutParams) {
                layoutParams.isFullSpan = true
                itemView.layoutParams = layoutParams
            }
        }
    }
}