package com.taobao.movie.android.app.oscar.ui.homepage.util

import com.taobao.movie.android.app.oscar.ui.homepage.model.LottieSwitch
import com.taobao.movie.android.integration.orange.ConfigUtil
import com.taobao.movie.android.integration.orange.OrangeConstants

class HomeLottieSwitchHelper private constructor() {

    private var lottieSwitch: LottieSwitch?=null

    companion object {
        val instance: HomeLottieSwitchHelper by lazy {
            HomeLottieSwitchHelper()
        }
    }

    fun isHomeBreadLottie(): Boolean = "true" == lottieSwitch?.homBread

    fun isHomeEnvBannerLottie(): Boolean = "true" == lottieSwitch?.homeEnvBanner

    fun isHomeThemeBannerLottie(): Boolean = "true" == lottieSwitch?.homeTheme

    fun isHomeMinus(): Boolean = "true" == lottieSwitch?.homeMinus

    init {
        lottieSwitch = ConfigUtil.getConfigCenterObj(LottieSwitch::class.java, OrangeConstants.CONFIG_KEY_HOME_LOTTIE, null)
        if (lottieSwitch == null) lottieSwitch = LottieSwitch()
    }

}

