package com.taobao.movie.android.app.oscar.ui.smartvideo.item

import android.view.View
import com.taobao.movie.android.app.oscar.ui.community.FilmFestivalIndexActivity
import com.taobao.movie.android.app.oscar.ui.community.fragment.FilmFestivalIndexFragment
import com.taobao.movie.android.app.oscar.ui.community.view.CommunityFestivalMoreItem
import com.taobao.movie.android.app.presenter.community.FilmFestivalVO
import com.taobao.movie.android.business.R
import com.taobao.movie.android.common.item.homepage.HomepageShowContainerBaseItem
import com.taobao.movie.appinfo.util.DataUtil

/**
 * 社区电影节Item
 */
class CommunityFestivalContainerItem(private val filmFestival: List<FilmFestivalVO>, listener: OnItemEventListener<*>?)
    : HomepageShowContainerBaseItem<List<FilmFestivalVO>>(filmFestival, listener), View.OnClickListener {

    override fun onBindViewHolder(viewHolder: ViewHolder?) {
        viewHolder?.initTitleContain()
        viewHolder?.initSoonShowTab()
        if (viewHolder == null || filmFestival.isNullOrEmpty()) return
        viewHolder.allTabTitles[0].visibility = View.GONE
        viewHolder.allTabTitles[1].visibility = View.GONE
        viewHolder.allTabTitles[2].visibility = View.GONE
        viewHolder.vsFlexboxLayout.visibility = View.GONE
        viewHolder.vsDivider2.visibility = View.GONE
        viewHolder.vsDivider3.visibility = View.GONE


        viewHolder.vsBillboardLayout.visibility = View.GONE
        viewHolder.vsTitleContainerLayout.visibility = View.VISIBLE
        viewHolder.vsTitle.setText("电影节")
        createItem(viewHolder)
        viewHolder.vsTitle.setOnClickListener(this)
        viewHolder.vsArrow.setOnClickListener(this)
    }

    private fun createItem(viewHolder: ViewHolder?) {
        if (viewHolder == null) {
            return
        }
        viewHolder.videoExpressAdapter?.clearItems()
        getData()?.forEach {
            viewHolder.videoExpressAdapter?.addItem(CommunityFestivalItem(it, listener))
        }
        if (DataUtil.getListSize(getData()) >= 8) {
            viewHolder.videoExpressAdapter?.addItem(CommunityFestivalMoreItem(0, listener))
        }
        viewHolder.videoExpressAdapter.notifyDataSetChanged()
        viewHolder.rvArticleFilmExpress.scrollToPosition(0)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.tv_homepage_show_container_title, R.id.tv_homepage_show_container_right_arrow -> {
                if (v?.context != null) {
                    FilmFestivalIndexActivity.gotoFilmFestivalIndexActivity(v.context, FilmFestivalIndexFragment.PAGE_FROM_FESTIVAL_TITLE)
                }
            }
        }
    }
}
