package com.taobao.movie.android.app.oscar.ui.smartvideo.item

import android.support.v7.widget.GridLayoutManager
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.View
import android.widget.TextView
import com.taobao.listitem.recycle.CustomRecyclerAdapter
import com.taobao.listitem.recycle.CustomRecyclerViewHolder
import com.taobao.listitem.recycle.RecyclerExtDataItem
import com.taobao.movie.android.app.oscar.ui.community.model.FilmFestivalItemModel
import com.taobao.movie.android.app.oscar.ui.community.model.FilmFestivalModel
import com.taobao.movie.android.home.R

/**
 * 电影节索引页item
 */
class FilmFestivalIndexItem(filmFestivalModel: FilmFestivalItemModel) : RecyclerExtDataItem<FilmFestivalIndexItem.ViewHolder,FilmFestivalItemModel>(filmFestivalModel){


    override fun onBindViewHolder(viewHolder: ViewHolder?) {
        viewHolder?.filmFestivalAdapter?.clearItems()
        viewHolder?.festivalTitle?.text = data.groupName
        if(!data.filmFestivalList.isNullOrEmpty()) {
            for(it in data.filmFestivalList) {
                viewHolder?.filmFestivalAdapter?.addItem(CommunityFilmFestivalItem(it))
            }
            viewHolder?.filmFestivalAdapter?.notifyItemRangeChanged(0,data.filmFestivalList.size)
        }
    }

    fun refreshFilmFestival(filmFestivalList : List<FilmFestivalModel>){
        if(viewHolder != null) {
            for(it in filmFestivalList) {
                viewHolder?.filmFestivalAdapter?.addItem(CommunityFilmFestivalItem(it),true)
            }
        }
    }

    override fun getLayoutId(): Int {
        return R.layout.film_festival_index_item
    }

    class ViewHolder(itemView: View) : CustomRecyclerViewHolder<FilmFestivalIndexItem>(itemView){
        val festivalTitle: TextView
        var filmFestivalAdapter: CustomRecyclerAdapter
        var filmFestivalRecycle: RecyclerView

        init {
            festivalTitle = itemView.findViewById(R.id.tv_film_festival_title)
            filmFestivalAdapter = CustomRecyclerAdapter(itemView.context)
            filmFestivalRecycle = itemView.findViewById(R.id.rv_film_festival_recycle)
            filmFestivalRecycle.layoutManager = GridLayoutManager(itemView.context,2)
            filmFestivalRecycle.adapter = filmFestivalAdapter
        }
    }
}