package com.taobao.movie.android.app.ui.product.viewmodel

import android.arch.lifecycle.LiveData
import android.arch.lifecycle.MutableLiveData
import com.taobao.movie.android.app.product.biz.motp.request.CouponBatchActivateRequest
import com.taobao.movie.android.arch.BaseViewModel
import com.taobao.movie.android.integration.product.model.CouponBatchActivateMo
import com.taobao.movie.android.net.mtop.rx.ApiException
import com.taobao.movie.android.net.mtop.rx.ShawShankApiObserver

class CouponBatchViewModel : BaseViewModel() {
    private val _activateResult = MutableLiveData<CouponBatchActivateMo>()
    val activateResult: LiveData<CouponBatchActivateMo>
        get() = _activateResult

    private val _errorMsg = MutableLiveData<String>()
    val errorMsg: LiveData<String>
        get() = _errorMsg

    fun activateCouponBatch(couponCode: String) {
        CouponBatchActivateRequest().apply {
            code = couponCode
            subscribe(this@CouponBatchViewModel, object: ShawShankApiObserver.ApiConsumer<CouponBatchActivateMo>() {
                override fun onSuccess(resp: CouponBatchActivateMo) {
                    _activateResult.value = resp
                }

                override fun onFail(e: ApiException) {
                    _errorMsg.value = e.message
                }
            })
        }
    }
}