package com.taobao.movie.android.app.ui.schedule.widget

import com.taobao.movie.appinfo.util.MovieCacheSet

object FirstTipManager {
    private const val KEY_FIRST_LUCKY_COUPON = "FIRST_LUCKY_COUPON"
    private const val KEY_FIRST_FESTIVAL_TIP = "FIRST_FESTIVAL_TIP"

    const val STATUS_DONE = -1
    const val STATUS_SHOW_NONE = 0
    const val STATUS_SHOW_FESTIVAL_TIP = 1
    const val STATUS_SHOW_LUCKY_TIP = 2

    var tipToShowStatus: Int = STATUS_SHOW_NONE

    fun checkShowStatus(hasFestivalTip: Boolean) {
        if (tipToShowStatus != STATUS_SHOW_NONE) {
            return
        }
        tipToShowStatus = if (hasFestivalTip && MovieCacheSet.getInstance().getBoolean(KEY_FIRST_FESTIVAL_TIP, true)) {
            STATUS_SHOW_FESTIVAL_TIP
        } else if (MovieCacheSet.getInstance().getBoolean(KEY_FIRST_LUCKY_COUPON, true)) {
            STATUS_SHOW_LUCKY_TIP
        } else {
            STATUS_SHOW_NONE
        }
    }

    fun resetShowStatus() {
        tipToShowStatus = STATUS_SHOW_NONE
    }

    fun onFestivalTipShown() {
        MovieCacheSet.getInstance().putBoolean(KEY_FIRST_FESTIVAL_TIP, false)
        tipToShowStatus = STATUS_DONE
    }

    fun onLuckyDialogShown() {
        MovieCacheSet.getInstance().putBoolean(KEY_FIRST_LUCKY_COUPON, false)
        tipToShowStatus = STATUS_DONE
    }
}