package com.taobao.movie.android.app.ui.schedule.widget

import com.alibaba.fastjson.JSON
import com.taobao.movie.android.app.presenter.schedule.NewLotteryDrawRequest
import com.taobao.movie.android.app.ui.schedule.model.DataPointModel
import com.taobao.movie.android.arch.BaseViewModel
import com.taobao.movie.android.common.Region.RegionExtServiceImpl
import com.taobao.movie.android.commonui.utils.SqmKeeper
import com.taobao.movie.android.net.mtop.rx.ApiException
import com.taobao.movie.android.net.mtop.rx.ShawShankApiObserver
import com.taobao.movie.android.integration.profile.model.LotteryDrawResultModel
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTConstants

class LotteryDrawViewModel: BaseViewModel() {
    @JvmOverloads
    fun doLottery(spmValue: String?, lotteryMixId: String, luckyMultiple:Boolean? = null, onSuccess: (LotteryDrawResultModel)->Unit,
                  onFailed:(ApiException)->Unit, onAlreadyDrawn:(()->Unit)? = null) {
        val newLotteryDrawRequest =  NewLotteryDrawRequest()
        if (spmValue != null && spmValue.isNotEmpty()) {
            newLotteryDrawRequest.dataPoint = JSON.toJSONString(DataPointModel("${UTConstants.SPM_APP_ID}.$spmValue.0.0", SqmKeeper.getSqmKeeper().currentValidSQM).apply {
                if (luckyMultiple != null) {
                    setLuckyMultiple(luckyMultiple)
                }
            })
        }
        newLotteryDrawRequest.lotteryMixId = lotteryMixId
        newLotteryDrawRequest.cityCode = RegionExtServiceImpl().userRegion.cityCode
        newLotteryDrawRequest.subscribe(this, object: ShawShankApiObserver.ApiConsumer<LotteryDrawResultModel?>() {
                    override fun onSuccess(resp: LotteryDrawResultModel?) {
                        if (resp != null) {
                            onSuccess(resp)
                        } else {
                            onFailed(ApiException())
                        }
                    }

                    override fun onFail(e: ApiException) {
                        if (e.returnCode == 200003 && onAlreadyDrawn != null) {
                            onAlreadyDrawn()
                        } else {
                            onFailed(e)
                        }
                    }
                })
    }
}