package com.taobao.movie.android.arch.items

import android.content.Context
import android.content.res.Resources
import android.support.v7.widget.RecyclerView
import android.view.View

open class CustomViewHolder<T>(itemView: View) : RecyclerView.ViewHolder(itemView) {

    var adapter: CustomListAdapter<T, out CustomViewHolder<T>>? = null

    open fun onCreate() {
    }

    open fun onBindItem(position: Int, itemData: T) {
    }

    fun getResources(): Resources? {
        return itemView.resources
    }

    fun getContext(): Context {
        return itemView.context
    }

    fun postClick(view: View) {
        view.setOnClickListener {
            adapter?.onItemClickListener?.onItemChildClick(view, adapterPosition, adapter as CustomListAdapter<T, CustomViewHolder<T>>)
        }
    }
}