package com.taobao.movie.android.arch.items

import android.support.v7.util.DiffUtil
import android.view.View

class RecyclerItem<T>(
        var listData: T,
        val id: Int,
        val type: Int = View.NO_ID,
        var tag: Any? = null
) : ItemData<T> {

    override fun getItemViewType(): Int {
        return type
    }

    override fun equals(other: Any?): Boolean {
        if (other is RecyclerItem<*>) {
            return type == other.type && listData == other.listData
        }
        return false
    }

    override fun hashCode(): Int {
        var result = listData?.hashCode() ?: 0
        result = 31 * result + id
        result = 31 * result + type
        result = 31 * result + (tag?.hashCode() ?: 0)
        return result
    }

    class DiffCallback<T> : DiffUtil.ItemCallback<RecyclerItem<T>>() {
        override fun areItemsTheSame(p0: RecyclerItem<T>, p1: RecyclerItem<T>): Boolean {
            return p0.id == p1.id
        }

        override fun areContentsTheSame(p0: RecyclerItem<T>, p1: RecyclerItem<T>): Boolean {
            return p0 == p1
        }
    }
}