package com.taobao.movie.android.common.item.homepage

import android.view.View
import android.widget.TextView
import com.taobao.listitem.recycle.CustomRecyclerViewHolder
import com.taobao.listitem.recycle.RecyclerExtDataItem
import com.taobao.movie.android.common.item.theme.ItemEvent
import com.taobao.movie.android.commonui.widget.shapebuilder.ShapeBuilder
import com.taobao.movie.android.component.R
import com.taobao.movie.android.sdk.infrastructure.usertrack.UTFacade
import com.taobao.movie.appinfo.util.DisplayUtil
import com.taobao.movie.appinfo.util.ResHelper

/**
 * 社区正在热映和即将上映查看更多
 */
class CommunityShowMoreItem(count: Int?, listener: RecyclerExtDataItem.OnItemEventListener<*>?) : RecyclerExtDataItem<CommunityShowMoreItem.ViewHolder, Int>(count, listener), View.OnClickListener {

    override fun onClick(v: View?) {
        UTFacade.buttonClickWithoutPage("NowShowingAllItemClick")
        onEvent(ItemEvent.EVENT_ID_COMMUNITY_GO_FILM_CALENDAR, "2") ////1=电影日历模块，2=查看更多
    }

    override fun onBindViewHolder(viewHolder: ViewHolder) {

        if (data != null && data > 0) {
            viewHolder.moreTitle.text = viewHolder.itemView.context.getText(R.string.film_detail_all_tag)
            viewHolder.moreDivider.visibility = View.VISIBLE
            viewHolder.moreCount.visibility = View.VISIBLE
            viewHolder.moreCount.text = "" + data + "部"
        } else {
            viewHolder.moreTitle.text = "查看全部"
            viewHolder.moreDivider.visibility = View.GONE
            viewHolder.moreCount.visibility = View.GONE
        }
        UTFacade.setSpmTag(viewHolder.itemView, "nowshowing.allitem")
        viewHolder.itemView.setOnClickListener(this)
        ShapeBuilder.create().radius(DisplayUtil.dp2px(6f)).solid(ResHelper.getColor(R.color.deliver_not_select)).build(viewHolder.view)
    }


    override fun getLayoutId(): Int {
        return R.layout.oscar_homepage_show_more_item
    }

    class ViewHolder(itemView: View) : CustomRecyclerViewHolder<CommunityShowMoreItem>(itemView) {
        var view: View
        var moreTitle: TextView
        var moreDivider: View
        var moreCount: TextView


        init {
            view = itemView.findViewById(R.id.rl_show_more_item)
            moreTitle = itemView.findViewById<View>(R.id.tv_homepage_show_more_title) as TextView
            moreDivider = itemView.findViewById(R.id.tv_homepage_show_more_divider)
            moreCount = itemView.findViewById<View>(R.id.tv_homepage_show_more_count) as TextView
        }
    }
}
