@file:JvmName("LoginExt")
package com.taobao.movie.android.common.login

import android.app.Activity
import android.support.v4.app.Fragment
import com.taobao.movie.android.commonui.utils.UiUtils
import com.taobao.movie.android.integration.common.service.LoginExtService

fun Activity.checkSession(afterLogin: ()->Unit) {
    if (LoginHelper.checkSessionValid()) {
        afterLogin()
        return
    }
    LoginHelper.preLoginWithDialog(this) {
        if (it == LoginExtService.LOGIN_SUCC && UiUtils.isActivityStateValid(this)) {
            afterLogin()
        }
    }
}

fun Fragment.checkSession(afterLogin: ()->Unit) = activity?.checkSession(afterLogin)