package com.taobao.movie.android.common.widget

import android.content.Context
import android.util.AttributeSet
import com.taobao.movie.android.business.R
import com.taobao.movie.android.commonui.widget.TppAnimImageView
import kotlin.math.max

/**
 * 从FeedCardImageView拷贝过来 社区feed的卡片显示专用
 */
class CommunityFeedCardImageView : TppAnimImageView {

    var minRatio = 0.56f
    var maxRatio = 1.04f

    constructor(context: Context) : this(context,null)

    constructor(context: Context,attributeSet: AttributeSet?) : super(context,attributeSet) {
        scaleType = ScaleType.CENTER_CROP
    }

    fun setData(imageUrl:String?,coverWidth : Int,coverHeight: Int,cardWidth: Int) {
        val layoutParams = layoutParams ?: return
        if (imageUrl.isNullOrEmpty()) {
            layoutParams.width = cardWidth
            layoutParams.height = cardWidth * 9/16
            uri = null
            setLocalDrawable(R.drawable.common_pic_item_bg)
            return
        }
        if (coverWidth <= 0 || coverHeight <= 0) {
            layoutParams.width = cardWidth
            layoutParams.height = cardWidth * 9/16
        } else {
            val ratio = coverHeight.toFloat()/coverWidth.toFloat()
            if (ratio > maxRatio) {
                layoutParams.width = cardWidth
                layoutParams.height = (cardWidth * maxRatio).toInt()
            } else if (ratio < minRatio) {
                layoutParams.width = cardWidth
                layoutParams.height = (cardWidth * minRatio).toInt()
            } else {
                layoutParams.width = cardWidth
                layoutParams.height = (cardWidth * ratio).toInt()
            }
        }
        setUrl(imageUrl)

    }
}