package com.taobao.movie.android.integration.monitor

import java.util.concurrent.ConcurrentHashMap

class OrderingDataMonitorManager {

    var dataMap = ConcurrentHashMap<String, OrderingDataModel>()

    companion object {
        private var orderingDataMonitorManager: OrderingDataMonitorManager? = null

        val instance: OrderingDataMonitorManager?
            get() {
                if (orderingDataMonitorManager == null) {
                    synchronized(OrderingDataMonitorManager::class.java) { orderingDataMonitorManager = OrderingDataMonitorManager() }
                }
                return orderingDataMonitorManager
            }
    }

    fun putData(apiName: String, data: OrderingDataModel) = dataMap.put(apiName, data)

    fun getData(apiName: String) : OrderingDataModel? =  dataMap.get(apiName)

    fun getTicketCacpaymentModel() : OrderingDataModel? = getData("mtop.film.mtopmarketingapi.cacpaymentsolution")

    fun getTicketOrderModel() : OrderingDataModel? = getData("mtop.film.mtopmarketingapi.cacpaymentsolution")

    fun getSaleCacpaymentModel() : OrderingDataModel? = getData("mtop.film.mtopsaleapi.salepaymentsolution")

    fun getSaleOrderModel() : OrderingDataModel? = getData("mtop.film.mtopsaleapi.createsaleorder")
}